DECLARE SUB RedrawAllScreens ()
DECLARE SUB ClearBackground ()
DECLARE SUB ClearViewports ()
DECLARE SUB DrawW1 (x%, y%, c%)
DECLARE SUB DrawW2 (x%, y%, c%)
DECLARE SUB DrawW3 (x%, y%, c%)
DECLARE SUB UndrawTic (y%)
DECLARE SUB DrawTic (y%)
DECLARE SUB DrawViewports ()
DECLARE SUB ClearWindow (i%)
DECLARE SUB Prompt (msg$)
DECLARE FUNCTION MIN! (a!, B!)
DECLARE FUNCTION MAX! (a!, B!)
DECLARE FUNCTION FLOOR! (x!)
DECLARE FUNCTION Test1! (x!, y!, z!, lambda!, omega!, octaves%)
DECLARE SUB SetPalette (WhichPalette)
DECLARE FUNCTION FBM! (x!, y!, z!, lambda!, omega!, octaves%)
DECLARE FUNCTION Turbulence! (x!, y!, z!, octaves%)
DECLARE SUB InitNoise ()
DECLARE FUNCTION Frac! (r!)
DECLARE FUNCTION Noise! (x!, y!, z!)
DECLARE SUB Initpalette (mapfile$, direction%)
DECLARE FUNCTION Shade& (red!, green!, blue!)
REM $DYNAMIC
COMMON SHARED SizeOfNoiseTable%
COMMON SHARED TRUE, FALSE
COMMON SHARED TestFunction, MaxTestFunctions
COMMON SHARED Maxx, Maxy, Maxcolors, Halfx, Halfy, ScreenCenter
COMMON SHARED XSize, YSize, XStep, YStep
COMMON SHARED BackgroundColor, PromptColor, FrameColor, NormalText
COMMON SHARED PromptRow, PromptColumn, QuickMode
COMMON SHARED TicStartColumn, TicEndColumn, TicLength
COMMON SHARED OldW3.x, OldW3.y, W3.CurrentRow
' ***********
'* BNOISE.BAS
'* Version 0.001a  Feb. 93
'* Copyright 1993 Dan Farmer. All Rights Reserved.
'* Workbench for experimenting with 3D functions.  The name comes
'* from the fact that it came to be as an experiment to help me understand
'* Perlin type noise functions and grew naturally to accomodate any of a
'* number of different functions.
'* Perlin noise functions were adopted from pseudo-code in
'* "Three-Dimensional Computer Graphics"
'*    by Alan Watt (ISBN 0 201 154420) Addison Wesley
'* That gorgeous rainbow palette courtesy of Jeff Bowermaster @Spat! Graphics
'* ( Jeff... will your fastvga.obj work with this?)
'*
'* There is no promise that the values from this program will be even
'* remotely similar to the results that these values would yield if used
'* in any other program <g>.  This includes raytracers.
'*
'* This *really* needs to be done in c, perhaps with SGVA graphics,
'* although that would take a bit of adjustment.  I've got a few too
'* many hard-coded values right now.  I will be cleaning those up later.
'* Honest.


FALSE = 0: TRUE = NOT FALSE

' NOTE: THIS WILL NEED TO BE UPDATED IF YOU ADD TO THE TEST1 FUNCTION!
TestFunction = 1
MaxTestFunctions = 8

' 30 is about the highest that you can go with this
SizeOfNoiseTable% = 30  'for the 3D Noise table.  Should be bigger.  Can't.
DIM SHARED NoiseTable%(SizeOfNoiseTable%, SizeOfNoiseTable%, SizeOfNoiseTable%)

' EGA palette array
DIM SHARED red(16), green(16), blue(16) AS INTEGER

' Histograph buffer
DIM Histograph(16) AS INTEGER

TYPE WindowStruct
	x1 AS INTEGER
	x2 AS INTEGER
	y1 AS INTEGER
	y2 AS INTEGER
	DrawMode AS INTEGER
	ActiveFlag AS INTEGER
	StepRate AS INTEGER
	Scale AS INTEGER
END TYPE
DIM SHARED W(6) AS WindowStruct

' Do the screen
CLS
LOCATE 1, 1: PRINT "Initializing Noise"
CALL InitNoise

' Set up screen parameters
SCREEN 12            ' 640x400x16
Maxcolors = 16
Maxx = 640            ' Actual screen maxx
Maxy = 480
ScreenCenter = Maxx / 2
XSize = 160           ' Window scales (upper-left window)
YSize = 160
Halfy = YSize / 2
Halfx = XSize / 2

BackgroundColor = 8
PromptColor = 9
FrameColor = BackgroundColor - 1
NormalText = 7

' Load the color map
'LOCATE 1, 1: PRINT "Intializing Palette"
MaxPalettes = 3
WhichPalette = 1
CALL SetPalette(WhichPalette)

octaves% = 6
lambda = 2
omega = .5
TurbScale = 1
TestFunction = 1

' Store function type names in this array.  It is used for both
' display of the current type, and for a scrolling picklist (not implemented)
NumTypes = 5
DIM SHARED FunctionTypes$(NumTypes)
FunctionType$(1) = "Turbulence"
FunctionType$(2) = "FBM       "
FunctionType$(3) = "Noise     "
FunctionType$(4) = "Random    "
FunctionType$(5) = "Custom    "
TurbType = 1

' Window #1 (TOP view) corners
' NOTE: These are the actual display coordinates.  Box frames are outside.

' Upper-left window
W(1).x1 = 8
W(1).y1 = 8
W(1).x2 = W(1).x1 + XSize
W(1).y2 = W(1).y1 + YSize
W(1).DrawMode = 1
W(1).ActiveFlag = TRUE
W(1).StepRate = 1
W(1).Scale = 1

' progress tic mark down right side of window #1
TicLength = 10
TicStartColumn = 8
TicEndColumn = TicStartColumn + TicLength


' Window #2 (SIDE view) corners

' Upper-right window
W(2).StepRate = 1
W(2).Scale = 10
W(2).x1 = Maxx - XSize - 8
W(2).y1 = 8
W(2).x2 = W(2).x1 + XSize
W(2).y2 = W(2).y1 + (Maxcolors * W(2).Scale)
W(2).DrawMode = 0
W(2).ActiveFlag = TRUE




' Coordinates for the 1st histograph window
W(3).StepRate = 4
W(3).Scale = 1
W(3).x1 = 8
W(3).y1 = 175
W(3).y2 = W(3).y1 + (16 * W(3).StepRate)
W(3).x2 = W(3).x1 + XSize * W(3).Scale
W(3).ActiveFlag = TRUE
W(3).DrawMode = 1

' Coordinates for the 2nd histograph window
W(4).StepRate = W(3).StepRate
W(4).Scale = W(3).Scale
W(4).y1 = 175
W(4).y2 = W(4).y1 + (16 * W(4).StepRate)
W(4).x2 = Maxx - 8
W(4).x1 = W(4).x2 - XSize
W(4).ActiveFlag = TRUE
W(4).DrawMode = 1
W(4).Scale = 1

' Coordinates for the "3D perspective" view (no box)
W(5).x1 = 8:
W(5).y1 = 250
W(5).x2 = Maxx - 8
W(5).y2 = Maxy - 8
W(5).DrawMode = 1
W(5).ActiveFlag = TRUE
W(5).StepRate = 1
W(5).Scale = 2


' Text window coords
PromptRow = 8
PromptColumn = 29
W(6).x1 = ScreenCenter - 100
W(6).x2 = ScreenCenter + 100
W(6).y1 = W(1).y1
W(6).y2 = W(1).y2 - 40
W(6).ActiveFlag = TRUE
W(6).DrawMode = 1
W(6).StepRate = 1
W(6).Scale = 1

z = 1

QuickMode = FALSE      ' Use fat pixels, sets XStep & YStep higher
IF QuickMode THEN
	XStep = XSize / 2: YStep = YSize / 2
ELSE
	XStep = 1: YStep = 1
END IF


CALL ClearBackground
CALL ClearViewports
DO
   ' These hold the previous values for Window #3
	OldW3.x = W(5).x1
	OldW3.y = W(5).y1 + 16 * W(5).Scale
	W3.CurrentRow = 1
	GOSUB ShowTextWindow

	FOR y% = -Halfy TO Halfy STEP YStep
		FOR x% = -Halfx TO Halfx STEP XStep

			' Scale points to fit Noise array
			sx = (ABS(x%) / XSize) * SizeOfNoiseTable%
			sy = (ABS(y%) / YSize) * SizeOfNoiseTable%

			SELECT CASE TurbType
			CASE 1
				n = Turbulence(sx, sy, z, octaves%) * TurbScale
			CASE 2
				n = FBM(sx, sy, z, lambda, omega, octaves%) * TurbScale
			CASE 3
				n = Noise(sx, sy, z) * TurbScale
			CASE 4
				n = RND(1) * TurbScale
			CASE 5
				n = Test1(sx, sy, z, lambda, omega, octaves%) * TurbScale
			CASE ELSE
			END SELECT

			IF (FALSE) THEN     ' Unused: place to put error-checking
				CALL Prompt("Out of range on type " + LTRIM$(STR$(TurbType)))
			END IF

			c% = n * Maxcolors
			IF c% > Maxcolors THEN c% = Maxcolors
			IF c% < 1 THEN c% = 1
			Histograph(c%) = Histograph(c%) + 1
			
			CALL DrawW1(x%, y%, c%)
			CALL DrawW2(x%, y%, c%)
			CALL DrawW3(x%, y%, c%)


			' Process all keystrokes here.
			k$ = INKEY$
			IF k$ <> "" THEN
				COLOR PromptColor
				k$ = UCASE$(k$)

				SELECT CASE k$
				CASE "1"
					 W(1).DrawMode = NOT W(1).DrawMode
				CASE "2"
					 W(2).DrawMode = NOT W(2).DrawMode
					 CALL ClearWindow(2)
				CASE "B"
					 BackgroundColor = BackgroundColor + 1
					 IF BackgroundColor > Maxcolors THEN BackgroundColor = 1
					 FrameColor = BackgroundColor - 1
					 CALL RedrawAllScreens
				CASE "G"                  ' Omega selection
					omega$ = ""
					CALL Prompt("New omega: ")
					LINE INPUT omega$
					omega = VAL(omega$)
					redraw = TRUE
				CASE "L"                  ' Lambda selection
					lambda$ = ""
					CALL Prompt("New lambda: ")
					LINE INPUT lambda$
					lambda = VAL(lambda$)
					redraw = TRUE
				CASE "M"                  ' Method selection
					GOSUB GetNewMethod
				CASE "O"                  ' Octaves selection
					DO
						octaves$ = ""
						CALL Prompt("New Octaves: ")
						LINE INPUT octaves$
					LOOP WHILE VAL(octaves$) < 1
					octaves% = VAL(octaves$)
					redraw = TRUE
				CASE "P"
					  WhichPalette = WhichPalette + 1
					  IF WhichPalette > MaxPalettes THEN WhichPalette = 1
					  CALL SetPalette(WhichPalette)
				CASE "Q"
					 QuickMode = NOT QuickMode
					 IF QuickMode THEN
						XStep = XSize / 2: YStep = YSize / 2
					 ELSE
						XStep = 1: YStep = 1
					 END IF
					 redraw = TRUE
				CASE "S"                  ' Scale selection
					DO
						TurbScale$ = ""
						CALL Prompt("New Scale: ")
						LINE INPUT TurbScale$
					LOOP WHILE VAL(TurbScale$) = 0
'**                    LOOP WHILE VAL(TurbScale$) < -25 OR VAL(TurbScale$) > 25
					TurbScale = VAL(TurbScale$)
					redraw = TRUE

				CASE CHR$(27)
					END
				CASE ELSE
					redraw = FALSE
				END SELECT
				COLOR NormalText
			END IF

			IF redraw THEN
'**                CALL UndrawTic(y%)
				CALL ClearViewports
				x% = XSize: y% = YSize    ' Jump out of both fox/next loops
				z = 1
				redraw = FALSE          ' Reset the flag
			END IF
		NEXT x%

		CALL UndrawTic(y%)
		OldW3.x = W(5).x1
		W3.CurrentRow = W3.CurrentRow + 1

		GOSUB DrawHistograms

	NEXT y%

	IF XStep + YStep > 2 THEN
		XStep = XStep * .5
		YStep = YStep * .5
	END IF

LOOP WHILE (1)
SCREEN 0
CLOSE all
END

'-------------------------------

' Print prompts and values
ShowTextWindow:
   
	AccentText = NormalText - 1
	IF AcctentText > 15 THEN AccentText = 15

	COLOR NormalText
	LOCATE 2, PromptColumn: PRINT " Method :    " + FunctionType$(TurbType)
	COLOR AccentText
	LOCATE 2, PromptColumn + 1: PRINT "M"
	COLOR NormalText

	SELECT CASE TurbType
	CASE 1    ' *** Regular Turbulated noise
		LOCATE 3, PromptColumn: PRINT USING " Octaves:   ##"; octaves%
		LOCATE 4, PromptColumn: PRINT USING " Scale  :   ##.##"; TurbScale
		COLOR AccentText
		LOCATE 3, PromptColumn + 1: PRINT "O"
		LOCATE 4, PromptColumn + 1: PRINT "S"
	CASE 2    ' *** FBM noise
		LOCATE 3, PromptColumn: PRINT USING " Octaves:   ##"; octaves%
		LOCATE 4, PromptColumn: PRINT USING " Scale  :   ##.##"; TurbScale
		LOCATE 5, PromptColumn: PRINT USING " Lambda :   ##.##"; lambda
		LOCATE 6, PromptColumn: PRINT USING " Omega  :   ##.##"; omega
		COLOR AccentText
		LOCATE 3, PromptColumn + 1: PRINT "O"
		LOCATE 4, PromptColumn + 1: PRINT "S"
		LOCATE 5, PromptColumn + 1: PRINT "L"
		LOCATE 6, PromptColumn + 4: PRINT "g"

	CASE 3  ' *** Raw Noise
		LOCATE 3, PromptColumn: PRINT USING " Scale  :   ##.##"; TurbScale
		COLOR AccentText
		LOCATE 3, PromptColumn + 1: PRINT "S"

	CASE 4  ' *** Random
		LOCATE 3, PromptColumn: PRINT USING " Scale  :   ##.##"; TurbScale
		COLOR AccentText
		LOCATE 3, PromptColumn + 1: PRINT "S"

	CASE 5    '*** Custom
		LOCATE 3, PromptColumn: PRINT USING " Octaves:   ##"; octaves%
		LOCATE 4, PromptColumn: PRINT USING " Scale  :   ##.##"; TurbScale
		LOCATE 5, PromptColumn: PRINT USING " Lambda :   ##.##"; lambda
		LOCATE 6, PromptColumn: PRINT USING " Omega  :   ##.##"; omega
		COLOR AccentText
		LOCATE 3, PromptColumn + 1: PRINT "O"
		LOCATE 4, PromptColumn + 1: PRINT "S"
		LOCATE 5, PromptColumn + 1: PRINT "L"
		LOCATE 6, PromptColumn + 4: PRINT "g"
		COLOR NormalText
		LOCATE 7, PromptColumn: PRINT USING " Custom function _# #"; TestFunction
	CASE ELSE
	END SELECT
	COLOR NormalText
RETURN

DrawHistograms:
'  Draw the color count histograms
FOR i% = 1 TO Maxcolors

	' Worst-case Histograph count = XSize
	ccount = Histograph(i%) * W(3).Scale
	astep = W(3).StepRate * i%
	IF W(3).DrawMode = 1 THEN
		' Window 4 tracks current row counts by erasing last
		LINE (W(3).x1, W(3).y1 + astep)-(W(3).x1 + XSize * W(3).Scale, W(3).y1 + astep), 0
		LINE (W(3).x1, W(3).y1 + astep)-(W(3).x1 + ccount, W(3).y1 + astep), i%
	END IF

	IF W(4).DrawMode = 1 THEN
	   ' Window 5 tracks max counts by not erasing prior values
		LINE (W(4).x2, W(4).y1 + astep)-(W(4).x2 - ccount, W(4).y1 + astep), i%
	END IF
	Histograph(i%) = 0
NEXT i%
RETURN


' Prompt user for new method
GetNewMethod:
	COLOR NormalText
	CALL Prompt("New Method: ")
	COLOR AccentText
	temp = PromptColumn
	PromptColumn = POS(0)

	' Scroll values by pressing keys
	DO
		TurbType = TurbType MOD NumTypes + 1

		CALL Prompt(FunctionType$(TurbType))

		k$ = "": WHILE k$ = "": k$ = INKEY$: WEND
		i% = INSTR("TFNRC", UCASE$(k$))
		IF i% > 0 THEN TurbType = i% - 1
	LOOP WHILE k$ <> CHR$(13) AND k$ <> CHR$(27)

	PromptColumn = temp

	IF INSTR(FunctionType$(TurbType), "Custom") > 0 THEN
		temp$ = "": temp = 0
		DO
			temp$ = SPACE$(LEN(temp$))
			CALL Prompt("Function #: 1 -> " + LTRIM$(STR$(MaxTestFunctions)) + " " + temp$)
			LOCATE PromptRow, POS(0) - LEN(temp$)
			LINE INPUT temp$
			temp = VAL(temp$)
		LOOP WHILE temp < 0 OR temp > MaxTestFunctions
		IF temp > 0 THEN TestFunction = temp
	END IF

	COLOR NormalText
	redraw = TRUE
RETURN

Palette1:
	DATA  0,  0,  0
	DATA 32,  0,  0
	DATA 42,  0,  0
	DATA 58, 16,  0
	DATA 63, 32,  0
	DATA 58, 56,  0
	DATA 16, 42,  0
	DATA  0, 30, 36
	DATA  0, 20, 40
	DATA  0, 10, 48
	DATA  0,  0, 63
	DATA 20,  0, 53
	DATA 23,  0, 29
	DATA 19,  7, 17
	DATA 50, 40, 45
	DATA 63, 63, 63

Palette2:
	DATA  0,  0,  0
	DATA  0, 32,  0
	DATA  0, 42,  0
	DATA 16, 58,  0
	DATA 32, 63,  0
	DATA 56, 58,  0
	DATA 42, 16,  0
	DATA 30,  0, 36
	DATA 20,  0, 40
	DATA 10,  0, 48
	DATA  0,  0, 63
	DATA  0, 20, 53
	DATA  0, 23, 29
	DATA  7, 19, 17
	DATA 40, 50, 45
	DATA 63, 63, 63

Palette3:
	DATA  0,  0,  0
	DATA  4,  4,  4
	DATA  8,  8,  8
	DATA 12, 12, 12
	DATA 16, 16, 16
	DATA 20, 20, 20
	DATA 24, 24, 24
	DATA 28, 28, 28
	DATA 32, 32, 32
	DATA 36, 36, 36
	DATA 40, 40, 40
	DATA 44, 44, 44
	DATA 48, 48, 48
	DATA 52, 52, 52
	DATA 56, 56, 56
	DATA 63, 63, 63

SUB ClearBackground STATIC
	CLS
	LINE (0, 0)-(Maxx, Maxy), BackgroundColor, BF   ' Clear screen to color 8
END SUB

SUB ClearViewports STATIC
' Clears all windows

	CALL DrawViewports         ' Draw the frames

	' Clear the viewports
	FOR i% = 1 TO 6
		CALL ClearWindow(i%)
	NEXT i%

'    GOSUB ShowTextWindow        ' Write stats
END SUB

SUB ClearWindow (i%) STATIC
	LINE (W(i%).x1, W(i%).y1)-(W(i%).x2, W(i%).y2), 0, BF
END SUB

SUB DrawTic (y%) STATIC
	' Draw a tic mark to show progress
	LINE (W(1).x2 + TicStartColumn, W(1).y1 + y% + Halfy)-(W(1).x2 + TicEndColumn, W(1).y1 + y% + Halfy), FrameColor
END SUB

SUB DrawViewports STATIC
' Draws frames around all windows

	' Draw a color bar alongside END view window
	lastpoint% = 1
	FOR i% = 1 TO 16
		nextpoint% = i% * W(2).Scale
		LINE (W(2).x1 - TicStartColumn, W(2).y2 - lastpoint%)-(W(2).x1 - TicLength, W(2).y2 - nextpoint%), i%, BF
		lastpoint% = nextpoint%
	NEXT i%
	FOR i% = 1 TO 6
		LINE (W(i%).x1 - 1, W(i%).y1 - 1)-(W(i%).x2 + 1, W(i%).y2 + 1), FrameColor, B
	NEXT i%
END SUB

SUB DrawW1 (x%, y%, c%) STATIC
	xp = W(1).x1 + x% + Halfx
	yp = W(1).y1 + y% + Halfy
	IF XStep + YStep = 2 THEN
		' Draw Upper-Left (TOP VIEW) window
		PSET (xp, yp), c%
	ELSE
		temp = XStep * .5
		x1 = W(1).x1: x2 = W(1).x2
		xp1 = MAX(xp - temp, x1)
		xp2 = MIN(xp + temp, x2)

		temp = YStep * .5
		y1 = W(1).y1: y2 = W(2).y2
		yp1 = MAX(yp - temp, y1)
		yp2 = MIN(yp + temp, y2)

		LINE (xp1, yp1)-(xp2, yp2), c%, BF
	END IF

	CALL DrawTic(y%)
END SUB

SUB DrawW2 (x%, y%, c%) STATIC

	xp = W(2).x1 + x% + Halfx
	LINE (xp, W(2).y1)-(xp, W(2).y2 - (c% * W(2).Scale)), 0

	' Mode FALSE will draw bars
	' Mode TRUE will plot points
	SELECT CASE W(2).DrawMode
	CASE FALSE
		LINE -(xp, W(2).y2 - 1), c%
		PSET (xp, W(2).y2 - (c% * W(2).Scale)), c%
	CASE TRUE
		LINE -(xp, W(2).y2 - 1), 0
		PSET (xp, W(2).y2 - (c% * W(2).Scale)), c%
	END SELECT
END SUB

SUB DrawW3 (x%, y%, c%) STATIC
	xp = W(5).x1 + ((Halfx + x%) * 3.9)
	yp = W(5).y1 + (W(5).Scale * Maxcolors - c%) + (W3.CurrentRow * YStep)
	temp = W(5).y2
	yp = MIN(yp, temp)               ' Keep within window
	PSET (OldW3.x, OldW3.y), c%      ' Start at last point
	LINE -(xp, yp), c%               ' Draw to current point
	OldW3.x = xp: OldW3.y = yp       ' Save this point for next pass
END SUB

FUNCTION FBM (x, y, z, omega, lambda, octaves%) STATIC
'
STATIC i%, l, o, value, tempx, tempy, tempz

value = Noise(x, y, z)
l = lambda
o = omega
FOR i% = 2 TO octaves%
	tempx = l * x
	tempy = l * y
	tempz = l * z
	value = value + o * Noise(tempx, tempy, tempz)
	IF i% < octaves% THEN
		l = l * lambda
		o = o * omega
	END IF
	FBM = value
NEXT i%
END FUNCTION

FUNCTION FLOOR (x) STATIC
	IF x > 0 THEN
		FLOOR = FIX(x)
	ELSE
		FLOOR = CINT(x)
	END IF
END FUNCTION

FUNCTION Frac (r) STATIC
Frac = r - FIX(r)
END FUNCTION

SUB InitNoise STATIC
STATIC x%, y%, z%
	FOR x% = 1 TO SizeOfNoiseTable%
		FOR y% = 1 TO SizeOfNoiseTable%
			FOR z% = 1 TO SizeOfNoiseTable%
				NoiseTable%(x%, y%, z%) = CINT(RND * 10000)
			NEXT z%
		NEXT y%
	NEXT x%
	PRINT "Noise Initialized"
END SUB

SUB Initpalette (mapfile$, direction%) STATIC
STATIC a, B, c
	OPEN mapfile$ FOR INPUT AS #1
	IF direction% = 1 THEN
		a = 0: B = 255: c = 1
	ELSE
		a = 255: B = 0: c = -1
	END IF
	FOR i% = a TO B STEP c
		INPUT #1, r!, g!, B!
		r! = r! / 255: g! = g! / 255: B! = B! / 255
		PALETTE i%, Shade&(r!, g!, B!)
	NEXT i%
	CLOSE #1
END SUB

FUNCTION MAX (a, B) STATIC
	IF a > B THEN MAX = a ELSE MAX = B
END FUNCTION

FUNCTION MIN (a, B) STATIC
	IF a < B THEN MIN = a ELSE MIN = B
END FUNCTION

FUNCTION Noise (x, y, z)
	' Offset x,y,z to ensure that they are positive
	x1 = x + 15000: y1 = y + 15000: z1 = z + 15000
	ix = FIX(x1) MOD SizeOfNoiseTable%
	iy = FIX(y1) MOD SizeOfNoiseTable%
	iz = FIX(z1) MOD SizeOfNoiseTable%
	ox = Frac(x1): oy = Frac(y1): oz = Frac(z1)

	' Interpolate to get noise value at (ix+ox,iy+oy,iz+oz)
	n = NoiseTable%(ix, iy, iz)
	n00 = n + ox * (NoiseTable%(ix + 1, iy, iz) - n)

	n = NoiseTable%(ix, iy, iz + 1)
	n01 = n + ox * (NoiseTable%(ix + 1, iy, iz + 1) - n)

	n = NoiseTable%(ix, iy + 1, iz)
	n10 = n + ox * (NoiseTable%(ix + 1, iy + 1, iz) - n)

	n = NoiseTable%(ix, iy + 1, iz + 1)
	n11 = n + ox * (NoiseTable%(ix + 1, iy + 1, iz + 1) - n)

	n0 = n00 + oy * (n10 - n00)
	n1 = n01 + oy * (n11 - n01)
	Noise = (n0 + oz * (n1 - n0)) * .0001
END FUNCTION

SUB Prompt (msg$) STATIC
	LOCATE PromptRow, PromptColumn
	PRINT msg$;
END SUB

SUB RedrawAllScreens STATIC
	CALL ClearBackground
	CALL DrawViewports
	CALL ClearViewports
'    GOSUB ShowTextWindow
END SUB

SUB SetPalette (WhichPalette) STATIC
STATIC x, y, colornum, KOLOR

	SELECT CASE WhichPalette
	CASE 1
		RESTORE Palette1
	CASE 2
		RESTORE Palette2
	CASE 3
		RESTORE Palette3
	CASE ELSE
		EXIT SUB
	END SELECT

	FOR y = 1 TO 4
	   FOR x = 1 TO 4
		   colornum = x + ((y - 1) * 4) - 1
		   READ red(colornum), green(colornum), blue(colornum)
		   KOLOR = 65536 * blue(colornum) + 256 * green(colornum) + red(colornum)
		   PALETTE colornum, KOLOR
		   COLOR colornum
	   NEXT x
	NEXT y
END SUB

FUNCTION Shade& (red!, green!, blue!) STATIC
	r& = red! * 63!
	g& = green! * 63!
	B& = blue! * 63!
	Shade& = r& + g& * 256& + B& * 65536
END FUNCTION

FUNCTION Test1 (x, y, z, omega, lambda, octaves%) STATIC
STATIC i%, value, Scale, retval
STATIC l, o, tempx, tempy, tempz

	MaxTestFunctions = 8         ' Initialize this at top of main file, too!

	SELECT CASE TestFunction
	CASE 1    ' *** Dumb.  Just a circular ramp from the origin
		value = 1 / SQR(x * x + y * y + z * z)
		retval = value

	CASE 2    ' *** Random bumplets
		Scale = 1
		FOR i% = 1 TO octaves%
			value = value + RND * SIN(x) * COS(y)
			value = value / i%
		NEXT i%
		retval = value

	CASE 3    ' *** Sort of a waffle-weave
		Scale = 1
		temp = 0
		value = 0
		FOR i% = 1 TO octaves%
			temp = SQR(ABS(TAN(x / Scale) + TAN(y / Scale) + TAN(z / Scale)))
			Scale = Scale * .5
			value = value + ABS(temp) * Scale
		NEXT i%
		retval = value

	CASE 4    ' *** Checkerboard
		value = FLOOR(x) + FLOOR(y) + FLOOR(z) AND 1
		retval = value

	CASE 5    ' *** Fascinating fractal shape
		Scale = 1
		temp = 0
		value = 0
		FOR i% = 1 TO octaves%
			temp = SQR(ABS(SIN(x / Scale) + COS(y / Scale) + COS(z / Scale)))
			Scale = Scale * .5
			value = value + ABS(temp) * Scale
		NEXT i%
		retval = value

	CASE 6    ' *** Hard to describe.  Little "ramps"?
		Scale = 1
		temp = 0
		value = 0
		FOR i% = 1 TO octaves%
			temp = Noise(SIN(x / Scale), COS(y / Scale), COS(z / Scale))
			Scale = Scale * .5
			value = value + ABS(temp) * Scale
		NEXT i%
		retval = value

	CASE 7    ' *** This is a keeper.  Little flowers.
		Scale = octaves%
		temp = 0
		value = 0
		FOR i% = 1 TO octaves%
			' Little "flowers"
			temp = Noise(ABS(SIN(x / Scale)), ABS(SIN(y / Scale)), ABS(SIN(z / Scale)))
			Scale = Scale * .5
			value = value + ABS(temp) * Scale
		NEXT i%
		retval = value

	CASE 8   ' *** FBM style
		value = Turbulence(x, y, z, octaves%)
		l = lambda
		o = omega
		FOR i% = 2 TO octaves%
			tempx = l * x
			tempy = l * y
			tempz = l * z
			value = value + o * Turbulence(tempx, tempy, tempz, i%)
			IF i% < octaves% THEN
				l = l * lambda
				o = o * omega
			END IF
			retval = value
		NEXT i%

	CASE ELSE
		retval = 0
	END SELECT
	Test1 = retval
END FUNCTION

FUNCTION Turbulence (x, y, z, octaves%) STATIC
STATIC i, t, Scale, value
	Scale = 1
	t = 0
	value = 1
	FOR i = 1 TO octaves%
		value = Noise(x / Scale, y / Scale, z / Scale)
		Scale = Scale * .5
		t = t + ABS(value) * Scale
	NEXT i
	Turbulence = t
END FUNCTION

SUB UndrawTic (y%) STATIC
	' Undraw the tic mark
	LINE (W(1).x2 + TicStartColumn, W(1).y1 + y% + Halfy)-(W(1).x2 + TicEndColumn, W(1).y1 + y% + Halfy), BackgroundColor
END SUB

