 ' Diamond generator by Ken Koehler
 ' Originally written for DKB
 ' Modified by Jeroen van den Bos for use with the Persistance of Vision -
 ' raytracer : April 1993
 ' Modified by Ken Tyler for use with Persistance of Vision - Raytracer
 ' Version 2.0 : Nov 25 1997
 ' Modified by Ken Tyler for use with Persistance of Vision - Raytracer
 ' Version 3.0 : July 14 1998

 DEFDBL A-Z
 CONST FALSE = 0
 CONST TRUE = NOT FALSE
 CONST pi = 3.141592653589#
 full.scene = TRUE

 PRINT
 PRINT " DIAMOND generator for the Persistance of Vision ray-tracer"
 PRINT " Original by Ken Koehler. Modified by Jeroen v.d.Bos for use with PoV 1.0"
 PRINT " Original by Ken Koehler. Modified by Ken Tyler for use with PoV 2.0"
 PRINT " Original by Ken Koehler. Modified by Ken Tyler for use with PoV 3.0"
 PRINT
 PRINT " *** Warning use even intergers only i.e.: 2, 4, 6, ... ***"
 INPUT "Number of sides          :"; s
 INPUT "Top Radius    from center:"; tr
 INPUT "Top Height    from center:"; th
 INPUT "Center Radius from center:"; cr
 INPUT "Bottom Depth  from center:"; bd
 SCREEN 12: PALETTE 1, 0 'was 1 and 7
 IF tr > cr THEN wy = tr ELSE wy = cr' get max dimension
 IF th > wy THEN bound = th ELSE bound = wy
 IF bd > wy THEN bound = bd
 wy = wy * 1.1           ' allow % extra screen space
 wx = wy * 1.5           ' adjust aspect ratio
 WINDOW (-wx, -wy)-(wx, wy)
  OPEN "diamond.pov" FOR OUTPUT AS #1
  IF full.scene THEN GOSUB WritePreText
  PRINT #1,
  PRINT #1, "#declare Diamond = mesh{"
  PRINT #1, "       // s ="; s; "  tr="; tr; "  th="; th; "  cr="; cr; "  bd="; bd
  ''' Constant
  IF tr > cr THEN size = tr ELSE size = cr
  IF th + bd > size THEN size = th + bd
  ark = 2 * pi / s / 2
  b1x = 0: b1y = -bd: b1z = 0
  a4x = 0: a4y = th: a4z = 0
  ''' Prep
  long.side = TRUE
  pointx = COS(-2.5 * ark): pointz = SIN(-2.5 * ark)
  a1x = pointx * cr: a1y = 0: a1z = pointz * cr
  c3x = pointx * tr: c3y = th: c3z = pointz * tr
 ' line (  0,  0)-(c3x,c3z),1
  LINE (c3x, c3z)-(a1x, a1z), 3
  FOR angle = (-1.5 * ark) TO (2 * pi) + (-2.5 * ark) STEP ark * 2
	  IF long.side = TRUE THEN pointx = COS(angle): pointz = SIN(angle)
	  IF long.side = FALSE THEN pointx = COS(angle + ark): pointz = SIN(angle + ark)
	  c1x = pointx * cr: c1y = 0: c1z = pointz * cr
	  b2x = pointx * tr: b2y = th: b2z = pointz * tr
    ' line (  0,  0)-(b2x,b2z),1
	  LINE (b2x, b2z)-(c1x, c1z), 3
	  LINE (c1x, c1z)-(a1x, a1z), 3
	  LINE (b2x, b2z)-(c3x, c3z), 1
	  GOSUB WritePoint
	  a1x = c1x: a1y = c1y: a1z = c1z
	  c3x = b2x: c3y = b2y: c3z = b2z
	  long.side = NOT long.side
  NEXT angle
  PRINT #1, "texture{DiamondTex}} // bounded_by {";
  IF th > bd THEN PRINT #1, "   // ** WARNING: Watch for bounding off of top surface **"
  PRINT #1, USING "   sphere { <0, 0, 0>, ###.## }"; bound * 1.01; ' MAX+1%
  PRINT #1, " }}"
  IF full.scene THEN GOSUB WritePostText
  CLOSE #1
  WHILE INKEY$ = "": WEND
  END

WritePreText:
  PRINT #1, " // Diamond generator by Ken Koehler"
  PRINT #1, " // Originally written for DKB"
  PRINT #1, " // Modified by Jeroen van den Bos for use with the Persistance of Vision -"
  PRINT #1, " // raytracer : April 1993"
  PRINT #1, " // Modified by Ken Tyler for use with Persistance of Vision - Raytracer"
  PRINT #1, " // Version 2.0 : Nov 25 1997"
  PRINT #1, " // Modified by Ken Tyler for use with Persistance of Vision - Raytracer"
  PRINT #1, " // Version 3.0 : July 14 1998"
  PRINT #1, "" 
  PRINT #1, " #include "; CHR$(34); "colors.inc"; CHR$(34)
  PRINT #1, " #include "; CHR$(34); "textures.inc"; CHR$(34)
  PRINT #1, " global_settings{assumed_gamma 2.2}"
  PRINT #1,
  PRINT #1, " #declare DiamondTex = texture{pigment{rgbf<.99,.99,.99,.99>}"
  PRINT #1, " finish{refraction 1 ior 2 reflection .1}}"
 RETURN

WritePostText:
  PRINT #1, ""
  PRINT #1, "  camera{"
  PRINT #1, USING "  location<0,####.##,####.##>"; th - (size / 1.5); -size * 2 ' was 1.5
  PRINT #1, "  direction <   0, 0, 1 >"
  PRINT #1, "  up        <   0, 1, 0 >"
  PRINT #1, "  right     < 4/3, 0, 0 >"
  PRINT #1, "  look_at ";
  PRINT #1, USING "  <0,####.##,0>}"; th - (size / 1.5) 
  PRINT #1, ""
  PRINT #1, USING " plane{y,####.## "; -bd * 1   
  PRINT #1, "  texture{pigment{checker color rgb<1,1,1>color rgb<.85,.85,.95>scale 6}"
  PRINT #1, "  finish{ambient .5 diffuse .1 reflection .1}}}"
  PRINT #1, ""
  PRINT #1, ""
  PRINT #1, " object{Diamond}"
  PRINT #1, ""
  PRINT #1, " light_source{<0,6,9>rgb 1}"
  PRINT #1, " light_source{<0,300,-90>rgb 1}"
  PRINT #1, ""
  PRINT #1, " // SkySphere "
  PRINT #1, "  sky_sphere{pigment{rgb<.5,.5,.6>}}"
  PRINT #1, ""
 RETURN

WritePoint:
  current.point% = current.point% + 1
  PRINT #1, USING "       // Side #### "; current.point%
  PRINT #1, USING "   triangle{<###.####,###.####,###.####>,<###.####,###.####,###.####>,<###.####,###.####,###.####>"; a1x; a1y; a1z; c1x; c1y; c1z; b1x; b1y; b1z;
  PRINT #1, "}"
  PRINT #1, USING "   triangle{<###.####,###.####,###.####>,<###.####,###.####,###.####>,<###.####,###.####,###.####>"; a1x; a1y; a1z; c1x; c1y; c1z; b2x; b2y; b2z;
  PRINT #1, "}"
  PRINT #1, USING "   triangle{<###.####,###.####,###.####>,<###.####,###.####,###.####>,<###.####,###.####,###.####>"; a1x; a1y; a1z; b2x; b2y; b2z; c3x; c3y; c3z;
  PRINT #1, "}"
  PRINT #1, USING "   triangle{<###.####,###.####,###.####>,<###.####,###.####,###.####>,<###.####,###.####,###.####>"; a4x; a4y; a4z; b2x; b2y; b2z; c3x; c3y; c3z;
  PRINT #1, "}"
 RETURN

