DEFDBL A-Z
CONST FALSE = 0
CONST TRUE = NOT FALSE
CONST pi = 3.141592653589#
CONST RAD2DEG = 360 / (2 * pi)
CONST BBClear = 0
CONST BBBound = 1
CONST BBX = 2
CONST BBY = 3
CONST BBZ = 4
DEF fnBBox$ (Func, a)
  STATIC Bound()
  SELECT CASE Func
	CASE BBClear
	  Max = 2 ^ 38
	  FOR k% = 0 TO 2
	b(k%) = Max
	b(k% + 3) = -Max
	  NEXT k%
	CASE BBBound
	  c$ = "bounded_by { box { <"
	  FOR k% = 0 TO 5
	IF k% = 3 THEN c$ = c$ + "> <"
	c$ = c$ + " " + STR$(b(k%))
	  NEXT k%
	  fnBBox$ = c$ + "> } }"
	CASE BBX
	  IF a < b(0) THEN b(0) = a
	  IF a > b(3) THEN b(3) = a
	CASE BBY
	  IF a < b(1) THEN b(1) = a
	  IF a > b(4) THEN b(4) = a
	CASE BBZ
	  IF a < b(2) THEN b(2) = a
	  IF a > b(5) THEN b(5) = a
	CASE ELSE
	  PRINT "Invalid BBox Function"; Func
  END SELECT
END DEF
DIM Bound(5)

Main:
  PRINT "GEAR generator for POVRay 1.0 by K. Koehler  v1.2"
  PRINT
  ' 03-08-91 KJK New program for DKB 2.05AB
  ' 03-21-92 KJK Updated for PVRAY 0.51
  '              Added .INC file (object only) versus .DAT (view/lights/etc)
  '              Actually, GEAR 1.1 was dropped, reworked 1.0 for 1.2.
  ' 08-19-92 KJK Updated for POVRay 1.0
  ' 08-23-92 KJK Better bound: Now by tooth.
  ' 12-19-97 KLT Updated for POVRay 2.2

'while (tooth$<>"P") 'and (tooth$<>"F")
'  input "Tooth type (Pointed/Flat):";Tooth$
'  if tooth$="p" then tooth$="P"
'  if tooth$="f" then tooth$="F"
'wend
tooth$ = "P"
WHILE (wheel$ <> "D") AND (wheel$ <> "S")
  INPUT "Wheel type (Disk/Spokes)     :"; wheel$
  wheel$ = UCASE$(LEFT$(wheel$, 1))
WEND
INPUT "Number of teeth                :"; nt
INPUT "Gear Radius         from center:"; dr
INPUT "Disk/Spoke Thicknes from center:"; dt
INPUT "Tooth Height                   :"; th
INPUT "Tooth&Hub Thickness from center:"; tt
INPUT "Axel Radius         from center:"; ar
INPUT "Hole/Spoke Multiple            :"; hm
IF hm THEN IF (nt MOD hm) THEN PRINT nt; "is not an even multiple of"; hm
'SCREEN 1: COLOR 7
SCREEN 12: PALETTE 2, 0
'if tooth$="F" then th=th*2              ' adjust for theoretic point
IF dr > dr + (th / 2) THEN wy = dr ELSE wy = dr + (th / 2)' get max XY dimension
boundxy = wy            ' save it for bounding
IF dt > tt THEN boundz = dt ELSE boundz = tt' get max Z dimension
wy = wy * 1.1           ' allow % extra screen space
wx = wy * 1.5           ' adjust aspect ratio
WINDOW (-wx, -wy)-(wx, wy)      ' create window sized for object

BuildExample:
  OPEN "gear.pov" FOR OUTPUT AS #1
  GOSUB DatTop
  GOSUB DatBottom
  CLOSE #1

BuildObject:
  OPEN "gear.inc" FOR OUTPUT AS #1
  PRINT #1, ""
  PRINT #1, "#declare GearTTex = texture { pigment { Red  } finish { Shiny }}"
  PRINT #1, "#declare GearHTex = texture { pigment { Blue } finish { Shiny }}"
  PRINT #1, "#declare GearWTex = texture { pigment { Red  } finish { Shiny }}"
  PRINT #1, ""
  PRINT #1, "#declare Gear ="
  PRINT #1, " union { object { union { "
  PRINT #1, " // '"; tooth$; "' '"; wheel$; "'  nt ="; nt; "  dr="; dr; "  dt="; dt; "  th="; th; "  tt="; tt; "  ar="; ar; "  hm="; hm
  ark = 2 * pi / nt / 2
  tp = dr + (th / 2)
  tb = dr - (th / 2)
  tr = tb - (th / 3)
  ab = ar * 1.5
  hb = tb / 2
  hr = tb / (nt / hm)
  a1x = COS(-ark) * tb: a1y = SIN(-ark) * tb: a1z = tt
  aspect = 4 * (wy / wx) / 3
  CIRCLE (0, 0), tb, 1, , , aspect
  IF tt > dt THEN CIRCLE (0, 0), tr, 1, , , aspect
  CIRCLE (0, 0), ar, 1, , , aspect
  IF tt > dt THEN CIRCLE (0, 0), ab, 1, , , aspect
  IF tt > dt OR wheel$ = "S" THEN GOSUB WriteHardened
  IF wheel$ = "D" THEN GOSUB WriteDisk
  IF wheel$ = "S" THEN GOSUB WriteSpokes
  PRINT #1, "}"
  PRINT #1, "}"
  FOR angle = 0 TO (2 * pi) - ark STEP ark * 2
	  b1x = COS(angle) * tp: b1y = SIN(angle) * tp: b1z = tt
	  LINE (a1x, a1y)-(b1x, b1y), 1
	  c1x = COS(angle + ark) * tb: c1y = SIN(angle + ark) * tb: c1z = tt
	  LINE (b1x, b1y)-(c1x, c1y), 1
	  IF tooth$ = "P" THEN GOSUB WriteToothPoint
	  IF tooth$ = "F" THEN GOSUB WriteToothFlat
	  a1x = c1x: a1y = c1y: a1z = c1z
  NEXT angle
  PRINT #1, " bounded_by {"
  PRINT #1, " intersection {"
  PRINT #1, " quadric { Cylinder_Z";
  PRINT #1, USING " scale <###.####, ###.####, 1.0>"; boundxy; boundxy;
  PRINT #1, "}"
  PRINT #1, USING " plane {< 0, 0,  1>, ###.#### }"; boundz
  PRINT #1, USING " plane {< 0, 0, -1>, ###.#### }"; boundz
  PRINT #1, "}}}"
  CLOSE #1
WHILE INKEY$ = "": WEND
END

WriteSpokes:
  spoke = 0
  FOR angle = 0 TO (2 * pi) - ark STEP (2 * pi) / (nt / hm)
	spoke = spoke + 1
	LINE (COS(angle) * ar, SIN(angle) * ar)-(COS(angle) * tb, SIN(angle) * tb), 1
	PRINT #1, USING "//Spoke ###"; spoke
	PRINT #1, "intersection {"
	PRINT #1, "quadric {Cylinder_Y";
	PRINT #1, USING " scale <###.####, 1, ###.####> texture {GearWTex} rotate <0, 0, ###.####>}"; dt; dt; angle * RAD2DEG
	PRINT #1, USING " plane {< 0,  1, 0>, ###.#### texture {GearWTex} rotate <0, 0, ###.####>}"; tb; angle * RAD2DEG
	PRINT #1, USING " plane {< 0, -1, 0>, ###.#### texture {GearWTex} rotate <0, 0, ###.####>}"; -ar; angle * RAD2DEG
	PRINT #1, "}"
'   print #1,using " rotate <0, 0, ###.####>";angle*RAD2DEG
  NEXT angle
RETURN

WriteDisk:
  PRINT #1, " //main disk"
  PRINT #1, " intersection {"
  PRINT #1, " quadric {Cylinder_Z";
  PRINT #1, USING " scale <###.####, ###.####, 1> texture {GearWTex}}"; tb; tb;
  PRINT #1, " quadric {Cylinder_Z";
  PRINT #1, USING " scale <###.####, ###.####, 1> inverse texture {GearWTex}}"; ar; ar
  PRINT #1, USING " plane {< 0, 0,  1>, ###.#### texture {GearWTex}}"; dt
  PRINT #1, USING " plane {< 0, 0, -1>, ###.#### texture {GearWTex}}"; dt
  IF hm THEN GOSUB DrillHoles
  PRINT #1, "}"
RETURN

DrillHoles:
  FOR angle = 0 TO (2 * pi) - ark STEP (2 * pi) / (nt / hm)
	  x = COS(angle) * hb: y = SIN(angle) * hb
	  CIRCLE (x, y), hr, 1, , , aspect
	  PRINT #1, " quadric { Cylinder_Z";
	  PRINT #1, USING " scale <###.####, ###.####, 1>"; hr; hr;
	  PRINT #1, USING " translate <###.####, ###.####, 0>"; x; y;
	  PRINT #1, " inverse }"
  NEXT angle
RETURN

WriteHardened:
  PRINT #1, "  //tooth base"
  PRINT #1, " intersection {"
  PRINT #1, " quadric {Cylinder_Z";
  PRINT #1, USING " scale <###.####, ###.####, 1> texture {GearHTex}}"; tb; tb
  PRINT #1, " quadric {Cylinder_Z";
  PRINT #1, USING " scale <###.####, ###.####, 1> inverse texture {GearHTex}}"; tr; tr
  PRINT #1, USING " plane {< 0, 0,  1>, ###.#### texture {GearHTex}}"; tt
  PRINT #1, USING " plane {< 0, 0, -1>, ###.#### texture {GearHTex}}"; tt
  PRINT #1, "}"
  PRINT #1, " //axel ring"
  PRINT #1, " intersection {"
  PRINT #1, " quadric {Cylinder_Z";
  PRINT #1, USING " scale <###.####, ###.####, 1> texture {GearHTex}}"; ab; ab
  PRINT #1, " quadric {Cylinder_Z";
  PRINT #1, USING " scale <###.####, ###.####, 1> inverse texture {GearHTex}}"; ar; ar
  PRINT #1, USING " plane {< 0, 0,  1>, ###.#### texture {GearHTex}}"; tt
  PRINT #1, USING " plane {< 0, 0, -1>, ###.#### texture {GearHTex}}"; tt
  PRINT #1, "}"
RETURN

WriteToothPoint:
  current.tooth% = current.tooth% + 1
  Bound$ = fnBBox$(BBClear, 0)
  Bound$ = fnBBox$(BBX, a1x)
  Bound$ = fnBBox$(BBY, a1y)
  Bound$ = fnBBox$(BBZ, a1z): Bound$ = fnBBox$(BBZ, -a1z)
  Bound$ = fnBBox$(BBX, b1x)
  Bound$ = fnBBox$(BBY, b1y)
  Bound$ = fnBBox$(BBZ, b1z): Bound$ = fnBBox$(BBZ, -b1z)
  Bound$ = fnBBox$(BBX, c1x)
  Bound$ = fnBBox$(BBY, c1y)
  Bound$ = fnBBox$(BBZ, c1z): Bound$ = fnBBox$(BBZ, -c1z)
  PRINT #1, " object { union {"
  PRINT #1, USING "  //Tooth #### "; current.tooth%
  PRINT #1, USING " triangle {<###.####, ###.####, ###.####>, <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####> texture {GearTTex}}"; a1x; a1y; a1z; b1x; b1y; b1z; c1x; c1y; c1z
  PRINT #1, USING " triangle {<###.####, ###.####, ###.####>, <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####> texture {GearTTex}}"; a1x; a1y; -a1z; b1x; b1y; -b1z; c1x; c1y; -c1z
  PRINT #1, USING " triangle {<###.####, ###.####, ###.####>, <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####> texture {GearTTex}}"; a1x; a1y; -a1z; b1x; b1y; b1z; b1x; b1y; -b1z
  PRINT #1, USING " triangle {<###.####, ###.####, ###.####>, <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####> texture {GearTTex}}"; a1x; a1y; -a1z; b1x; b1y; b1z; a1x; a1y; a1z
  PRINT #1, USING " triangle {<###.####, ###.####, ###.####>, <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####> texture {GearTTex}}"; c1x; c1y; -c1z; b1x; b1y; b1z; b1x; b1y; -b1z
  PRINT #1, USING " triangle {<###.####, ###.####, ###.####>, <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####> texture {GearTTex}}}"; c1x; c1y; -c1z; b1x; b1y; b1z; c1x; c1y; c1z
  Bound$ = fnBBox$(BBBound, 0)
  PRINT #1, "      "; Bound$
  PRINT #1, "}"
RETURN

WriteToothFlat:
  current.tooth% = current.tooth% + 1
  PRINT #1, USING " //Tooth #### "; current.tooth%
  PRINT #1, USING "object { triangle {<###.####, ###.####, ###.####><###.####, ###.####, ###.####><###.####, ###.####, ###.####>}"; a1x; a1y; a1z; b1x; b1y; b1z; c1x; c1y; c1z;
  PRINT #1, " texture { GearTTex }}"
  PRINT #1, USING "object { triangle {<###.####, ###.####, ###.####><###.####, ###.####, ###.####><###.####, ###.####, ###.####>}"; a1x; a1y; -a1z; b1x; b1y; -b1z; c2x; c2y; -c2z;
  PRINT #1, " texture { GearTTex }}"
  PRINT #1, USING "object { triangle {<###.####, ###.####, ###.####><###.####, ###.####, ###.####><###.####, ###.####, ###.####>}"; a1x; a1y; -a1z; b1x; b1y; b1z; b1x; b1y; -b1z;
  PRINT #1, " texture { GearTTex }}"
  PRINT #1, USING "object { triangle {<###.####, ###.####, ###.####><###.####, ###.####, ###.####><###.####, ###.####, ###.####>}"; a1x; a1y; -a1z; b1x; b1y; b1z; a1x; a1y; a1z;
  PRINT #1, " texture { GearTTex }}"
  PRINT #1, USING "object { triangle {<###.####, ###.####, ###.####><###.####, ###.####, ###.####><###.####, ###.####, ###.####>}"; c1x; c1y; -c1z; b1x; b1y; b1z; b1x; b1y; -b1z;
  PRINT #1, " texture { GearTTex }}"
  PRINT #1, USING "object { triangle {<###.####, ###.####, ###.####><###.####, ###.####, ###.####><###.####, ###.####, ###.####>}"; c1x; c1y; -c1z; b1x; b1y; b1z; c1x; c1y; c1z;
  PRINT #1, " texture { GearTTex }}"
RETURN

DspFile:
  PRINT #1, ""
  PRINT #1, "camera {"
  PRINT #1, " location  <  0, 0, "; -wy * 2; ">"
  PRINT #1, " direction <  0, 0, 1>"
  PRINT #1, " up        <  0, 1, 0>"
  PRINT #1, " right     <4/3, 0, 0>"
  PRINT #1, " look_at   <  0, 0, 0>}"
  PRINT #1, ""
  PRINT #1, " object {"
  PRINT #1, " plane { <0, 1, 0>, "; -wx; "}"
  PRINT #1, " texture { pigment {"
  PRINT #1, " checker color Red color Maroon }"
' print #1, " scale <";wy;," ";wy;," ";wy;">"
  PRINT #1, " finish { ambient 0.3 diffuse 0.7 }}}"
  PRINT #1, ""
  PRINT #1, "object { Gear rotate <0, -30, 0>}"
  PRINT #1, ""
  PRINT #1, " light_source { ";
  PRINT #1, "<"; 10 * wy; , " "; 12 * wy; , " "; -13 * wy; ">";
  PRINT #1, " color White }"
RETURN

DatTop:
  PRINT #1, ""
  PRINT #1, "#include "; CHR$(34); "shapes.inc"; CHR$(34)
  PRINT #1, "#include "; CHR$(34); "colors.inc"; CHR$(34)
  PRINT #1, "#include "; CHR$(34); "textures.inc"; CHR$(34)
  PRINT #1, ""
RETURN

DatBottom:
  PRINT #1, ""
  PRINT #1, "#include "; CHR$(34); "gear.inc"; CHR$(34)
  PRINT #1, ""
  GOSUB DspFile
RETURN

