defdbl a-z
const FALSE= 0
const TRUE = NOT FALSE
CONST PI = 3.141592653589#
CONST RAD2DEG = 360/(2*PI)
const BBClear = 0
const BBBound = 1
const BBX     = 2
const BBY     = 3
const BBZ     = 4
def fnBBox$(Func,a)
  static Bound()
  SELECT CASE Func
    CASE BBClear
      Max=2^38
      for k%=0 to 2
	b(k%)  = Max
	b(k%+3)=-Max
      next k%
    CASE BBBound
      c$="bounded_by { box { <"
      for k%= 0 to 5
	if k%=3 then c$=c$+"> <"
	c$=c$+" "+str$(b(k%))
      next k%
      fnBBox$=c$+"> } }"
    CASE BBX
      if a<b(0) then b(0)=a
      if a>b(3) then b(3)=a
    CASE BBY
      if a<b(1) then b(1)=a
      if a>b(4) then b(4)=a
    CASE BBZ
      if a<b(2) then b(2)=a
      if a>b(5) then b(5)=a
    CASE ELSE
      print "Invalid BBox Function";Func
  END SELECT
END DEF
dim Bound(5)

Main:
  print "GEAR generator for POVRay 1.0 by K. Koehler  v1.2"
  print
  ' 03-08-91 KJK New program for DKB 2.05AB
  ' 03-21-92 KJK Updated for PVRAY 0.51
  '              Added .INC file (object only) versus .DAT (view/lights/etc)
  '              Actually, GEAR 1.1 was dropped, reworked 1.0 for 1.2.
  ' 08-19-92 KJK Updated for POVRay 1.0
  ' 08-23-92 KJK Better bound: Now by tooth.

'while (tooth$<>"P") 'and (tooth$<>"F")
'  input "Tooth type (Pointed/Flat):";Tooth$
'  if tooth$="p" then tooth$="P"
'  if tooth$="f" then tooth$="F"
'wend
tooth$="P"
while (wheel$<>"D") and (wheel$<>"S")
  input "Wheel type (Disk/Spokes)     :";wheel$
  wheel$=ucase$(left$(wheel$,1))
wend
input "Number of teeth                :";nt
input "Gear Radius         from center:";dr
input "Disk/Spoke Thicknes from center:";dt
input "Tooth Height                   :";th
input "Tooth&Hub Thickness from center:";tt
input "Axel Radius         from center:";ar
input "Hole/Spoke Multiple            :";hm
if hm then if (nt mod hm) then print nt;"is not an even multiple of";hm
screen 1 : color 7
'if tooth$="F" then th=th*2              ' adjust for theoretic point
if dr>dr+(th/2) then wy=dr else wy=dr+(th/2) ' get max XY dimension
boundxy=wy				' save it for bounding
if dt>tt then boundz=dt else boundz=tt	' get max Z dimension
wy=wy*1.1				' allow % extra screen space
wx=wy*1.5				' adjust aspect ratio
window (-wx,-wy) - (wx,wy)		' create window sized for object

BuildExample:
  open "gear.pov" for output as #1
  gosub DatTop
  gosub DatBottom
  close #1

BuildObject:
  open "gear.inc" for output as #1
  print #1,"
  print #1,"#declare GearTTex  = texture { Shiny  colour Red  }
  print #1,"#declare GearHTex  = texture { Shiny  colour Blue }
  print #1,"#declare GearWTex  = texture { Shiny  colour Red  }
  print #1,"
  print #1,"#declare Gear =
  print #1,"  composite {
  print #1,"    object {
  print #1,"      union {
  print #1,"         // '";tooth$;"' '";wheel$;"'  nt =";nt;"  dr=";dr;"  dt=";dt;"  th=";th;"  tt=";tt;"  ar=";ar;"  hm=";hm
  ark=2*pi/nt/2
  tp=dr+(th/2)
  tb=dr-(th/2)
  tr=tb-(th/3)
  ab=ar*1.5
  hb=tb/2
  hr=tb/(nt/hm)
  a1x=cos(-ark)*tb : a1y=sin(-ark)*tb : a1z=tt
  aspect=4*(wy/wx)/3
  circle (0,0),tb,1,,,aspect
  if tt>dt then circle (0,0),tr,1,,,aspect
  circle (0,0),ar,1,,,aspect
  if tt>dt then circle (0,0),ab,1,,,aspect
  if tt>dt or wheel$="S" then gosub WriteHardened
  if wheel$="D" then gosub WriteDisk
  if wheel$="S" then gosub WriteSpokes
  print #1,	 "      }
  print #1,	 "    }
  for angle = 0 to (2*pi)-ark step ark*2
      b1x=cos(angle)*tp     : b1y=sin(angle)*tp     : b1z=tt
      line (a1x,a1y)-(b1x,b1y),1
      c1x=cos(angle+ark)*tb : c1y=sin(angle+ark)*tb : c1z=tt
      line (b1x,b1y)-(c1x,c1y),1
      if tooth$="P" then gosub WriteToothPoint
      if tooth$="F" then gosub WriteToothFlat
      a1x=c1x : a1y=c1y : a1z=c1z
  next angle
  print #1,	 "    bounded_by {"
  print #1,	 "      intersection {"
  print #1,	 "        quadric { Cylinder_Z";
  print #1,using " scale <###.#### ###.#### 1.0>";boundxy;boundxy;
  print #1,	 " }
  print #1,using "        plane {< 0.0 0.0  1.0> ###.#### }";boundz
  print #1,using "        plane {< 0.0 0.0 -1.0> ###.#### }";boundz
  print #1,	 "      }
  print #1,	 "    }
  print #1,	 "  }
  close #1
while inkey$="":wend
end

WriteSpokes:
  spoke=0
  for angle = 0 to (2*pi)-ark step (2*PI)/(nt/hm)
    spoke=spoke+1
    line (cos(angle)*ar,sin(angle)*ar)-(cos(angle)*tb,sin(angle)*tb),1
    print #1,using "        //Spoke ###";spoke
    print #1,	   "        intersection {"
    print #1,	   "          quadric {Cylinder_Y";
    print #1,using " scale <###.#### 1.0 ###.####> texture {GearWTex} rotate <0 0 ###.####> }";dt;dt;angle*RAD2DEG
    print #1,using "          plane { < 0.0  1.0 0.0> ###.#### texture {GearWTex} rotate <0 0 ###.####> }";tb;angle*RAD2DEG
    print #1,using "          plane { < 0.0 -1.0 0.0> ###.#### texture {GearWTex} rotate <0 0 ###.####> }";-ar;angle*RAD2DEG
    print #1,	   "        }
'   print #1,using "        rotate <0 0 ###.####>";angle*RAD2DEG
  next angle
return

WriteDisk:
  print #1,	 "        //main disk
  print #1,	 "        intersection {"
  print #1,	 "          quadric {Cylinder_Z";
  print #1,using " scale <###.#### ###.#### 1.0> texture {GearWTex}}";tb;tb;
  print #1,	 "          quadric {Cylinder_Z";
  print #1,using " scale <###.#### ###.#### 1.0> inverse texture {GearWTex}}";ar;ar
  print #1,using "          plane { < 0.0 0.0  1.0> ###.#### texture {GearWTex}}";dt
  print #1,using "          plane { < 0.0 0.0 -1.0> ###.#### texture {GearWTex}}";dt
  if hm then gosub DrillHoles
  print #1,	 "        }
return

DrillHoles:
  for angle = 0 to (2*pi)-ark step (2*pi)/(nt/hm)
      x=cos(angle)*hb : y=sin(angle)*hb
      circle (x,y),hr,1,,,aspect
      print #1,      "          quadric { Cylinder_Z";
      print #1,using " scale <###.#### ###.#### 1.0>";hr;hr;
      print #1,using " translate <###.#### ###.#### 0.0>";x;y;
      print #1,      " inverse }
  next angle
return

WriteHardened:
  print #1,	 "        //tooth base
  print #1,	 "        intersection {"
  print #1,	 "          quadric {Cylinder_Z";
  print #1,using " scale <###.#### ###.#### 1.0> texture {GearHTex}}";tb;tb
  print #1,	 "          quadric {Cylinder_Z";
  print #1,using " scale <###.#### ###.#### 1.0> inverse texture {GearHTex}}";tr;tr
  print #1,using "          plane { < 0.0 0.0  1.0> ###.#### texture {GearHTex}}";tt
  print #1,using "          plane { < 0.0 0.0 -1.0> ###.#### texture {GearHTex}}";tt
  print #1,	 "       }
  print #1,	 "        //axel ring
  print #1,	 "        intersection {"
  print #1,	 "          quadric {Cylinder_Z";
  print #1,using " scale <###.#### ###.#### 1.0> texture {GearHTex}}";ab;ab
  print #1,	 "          quadric {Cylinder_Z";
  print #1,using " scale <###.#### ###.#### 1.0> inverse texture {GearHTex} }";ar;ar
  print #1,using "          plane { < 0.0 0.0  1.0> ###.#### texture {GearHTex}}";tt
  print #1,using "          plane { < 0.0 0.0 -1.0> ###.#### texture {GearHTex}}";tt
  print #1,	 "        }
return

WriteToothPoint:
  current.tooth%=current.tooth%+1
  Bound$=fnBBox$(BBClear,0)
  Bound$=fnBBox$(BBX,a1x)
  Bound$=fnBBox$(BBY,a1y)
  Bound$=fnBBox$(BBZ,a1z) :Bound$=fnBBox$(BBZ,-a1z)
  Bound$=fnBBox$(BBX,b1x)
  Bound$=fnBBox$(BBY,b1y)
  Bound$=fnBBox$(BBZ,b1z) :Bound$=fnBBox$(BBZ,-b1z)
  Bound$=fnBBox$(BBX,c1x)
  Bound$=fnBBox$(BBY,c1y)
  Bound$=fnBBox$(BBZ,c1z) :Bound$=fnBBox$(BBZ,-c1z)
  print #1,	 "    object {
  print #1,	 "      union {
  print #1,using "       //Tooth #### ";current.tooth%
  print #1,using "        triangle { <###.#### ###.#### ###.####> <###.#### ###.#### ###.####> <###.#### ###.#### ###.####>  texture {GearTTex} }" ;a1x;a1y; a1z ;b1x;b1y; b1z ;c1x;c1y; c1z
  print #1,using "        triangle { <###.#### ###.#### ###.####> <###.#### ###.#### ###.####> <###.#### ###.#### ###.####>  texture {GearTTex} }" ;a1x;a1y;-a1z ;b1x;b1y;-b1z ;c1x;c1y;-c1z
  print #1,using "        triangle { <###.#### ###.#### ###.####> <###.#### ###.#### ###.####> <###.#### ###.#### ###.####>  texture {GearTTex} }" ;a1x;a1y;-a1z ;b1x;b1y; b1z ;b1x;b1y;-b1z
  print #1,using "        triangle { <###.#### ###.#### ###.####> <###.#### ###.#### ###.####> <###.#### ###.#### ###.####>  texture {GearTTex} }" ;a1x;a1y;-a1z ;b1x;b1y; b1z ;a1x;a1y; a1z
  print #1,using "        triangle { <###.#### ###.#### ###.####> <###.#### ###.#### ###.####> <###.#### ###.#### ###.####>  texture {GearTTex} }" ;c1x;c1y;-c1z ;b1x;b1y; b1z ;b1x;b1y;-b1z
  print #1,using "        triangle { <###.#### ###.#### ###.####> <###.#### ###.#### ###.####> <###.#### ###.#### ###.####>  texture {GearTTex} }" ;c1x;c1y;-c1z ;b1x;b1y; b1z ;c1x;c1y; c1z
  print #1,	 "      }
  Bound$=fnBBox$(BBBound,0)
  print #1,	 "      ";Bound$
  print #1,	 "    }
return

WriteToothFlat:
  current.tooth%=current.tooth%+1
  print #1, using "       //Tooth #### ";current.tooth%
  print #1, using "    OBJECT TRIANGLE <###.#### ###.#### ###.####> <###.#### ###.#### ###.####> <###.#### ###.#### ###.####>" ;a1x;a1y; a1z ;b1x;b1y; b1z ;c1x;c1y; c1z;
  print #1,	  " END_TRIANGLE COLOUR GearT00Col TEXTURE GearTTex END_TEXTURE END_OBJECT"
  print #1, using "    OBJECT TRIANGLE <###.#### ###.#### ###.####> <###.#### ###.#### ###.####> <###.#### ###.#### ###.####>" ;a1x;a1y;-a1z ;b1x;b1y;-b1z ;c2x;c2y;-c2z;
  print #1,	  " END_TRIANGLE COLOUR GearT00Col TEXTURE GearTTex END_TEXTURE END_OBJECT"
  print #1, using "    OBJECT TRIANGLE <###.#### ###.#### ###.####> <###.#### ###.#### ###.####> <###.#### ###.#### ###.####>" ;a1x;a1y;-a1z ;b1x;b1y; b1z ;b1x;b1y;-b1z;
  print #1,	  " END_TRIANGLE COLOUR GearT00Col TEXTURE GearTTex END_TEXTURE END_OBJECT"
  print #1, using "    OBJECT TRIANGLE <###.#### ###.#### ###.####> <###.#### ###.#### ###.####> <###.#### ###.#### ###.####>" ;a1x;a1y;-a1z ;b1x;b1y; b1z ;a1x;a1y; a1z;
  print #1,	  " END_TRIANGLE COLOUR GearT00Col TEXTURE GearTTex END_TEXTURE END_OBJECT"
  print #1, using "    OBJECT TRIANGLE <###.#### ###.#### ###.####> <###.#### ###.#### ###.####> <###.#### ###.#### ###.####>" ;c1x;c1y;-c1z ;b1x;b1y; b1z ;b1x;b1y;-b1z;
  print #1,	  " END_TRIANGLE COLOUR GearT00Col TEXTURE GearTTex END_TEXTURE END_OBJECT"
  print #1, using "    OBJECT TRIANGLE <###.#### ###.#### ###.####> <###.#### ###.#### ###.####> <###.#### ###.#### ###.####>" ;c1x;c1y;-c1z ;b1x;b1y; b1z ;c1x;c1y; c1z;
  print #1,	  " END_TRIANGLE COLOUR GearT00Col TEXTURE GearTTex END_TEXTURE END_OBJECT"
return

DspFile:
  print #1,"
  print #1,"camera {
  print #1,"   location  <0.0 0.0 ";-wy*2;">"
  print #1,"   direction <0.0 0.0 1.0>
  print #1,"   up  <0.0  1.0  0.0>
  print #1,"   right <1.33333 0.0 0.0>
  print #1,"   look_at <0.0 0.0 0.0>"
  print #1,"}
  print #1,"
  print #1,"/* put down the beloved famous raytrace green/yellow checkered floor */
  print #1,"object {
  print #1,"   plane { <0.0 1.0 0.0> ";-wx;"}"
  print #1,"   texture {
  print #1,"      checker colour Yellow colour Green
' print #1,"      scale <";wy;" ";wy;" ";wy;">"
  print #1,"      ambient 0.3
  print #1,"      diffuse 0.7
  print #1,"   }
  print #1,"}
  print #1,"
  print #1,"composite {
  print #1,"    Gear  rotate <0 -30 0>
  print #1,"}
  print #1,"
  print #1,"object { light_source { ";
  print #1,"<";10*wy;" ";12*wy;" ";-13*wy;">";
  print #1," colour White } }"
return

DatTop:
  print #1,"// Persistence of Vision Raytracer
  print #1,"#include ";chr$(34);"shapes.inc";chr$(34)
  print #1,"#include ";chr$(34);"colors.inc";chr$(34)
  print #1,"#include ";chr$(34);"textures.inc";chr$(34)
  print #1,"
  print #1,"//----------------------- Definitions start here -----------------------
return

DatBottom:
  print #1,"
  print #1,"#include ";chr$(34);"gear.inc";chr$(34)
  print #1,"
  print #1,"//----------------------- Display starts here --------------------------
  print #1,"
  gosub DspFile
return
