DECLARE FUNCTION Gauss! (samples%)
DECLARE FUNCTION Distribution% (x%)
DECLARE FUNCTION CubicBlend% (t%, N1%, N2%, P1%, P2%)
DECLARE FUNCTION HermiteBlend% (t%, N1%, N2%, P1%, P2%)
DECLARE FUNCTION LathamBlend% (angle%)
DECLARE FUNCTION LinearBlend% (t%, N1%, N2%)
DECLARE FUNCTION QuadraticBlend% (t%, N1%, N2%, P1%)
DECLARE FUNCTION XanderBlend% (t%, P1%)
DECLARE SUB Adjust1 (xa%, ya%, x%, y%, xb%, yb%)
DECLARE FUNCTION Sqrt& (n&)
DECLARE SUB Adjust2 (xa%, ya%, x%, y%, xb%, yb%)
DECLARE SUB Putpixel (x%, y%, c%)
DECLARE SUB Subdivide (x1%, y1%, x2%, y2%)
DECLARE SUB Pause ()
DECLARE SUB Adjust (xa%, ya%, x%, y%, xb%, yb%)
DECLARE FUNCTION Getpixel% (x%, y%)

' QuickBASIC conversion of the classic PLASMA program.
' Conversion by Dan Farmer
' Note: I put an ESC test in the PutPixel routine, since I'd otherwise
' need two copies, one in Adjust, and one in Subdivide to get the same
' sort of response.  Inkey$ can cause troubles when run in an OS/2 DOS
' session.

DEFINT A-Z
COMMON SHARED MAXCOLOR, BGCOLOR, MINX, MINY, MAXX, MAXY, GRANULARITY
DIM SHARED HISTO(256)

' Increase stack space for recursion
stack = FRE(-2)
CLEAR , , stack

MAXCOLOR = 255
BGCOLOR = 0

CLS
SCREEN 13

MINX = 0
MINY = 0
MAXX = 320
MAXY = 200


GRANULARITY = 30
Seed = 12345.9999#
RANDOMIZE Seed

Putpixel MINX, MINY, Distribution(MAXCOLOR) + 1
Putpixel MAXX, MINY, Distribution(MAXCOLOR) + 1
Putpixel MAXX, MAXY, Distribution(MAXCOLOR) + 1
Putpixel MINX, MAXY, Distribution(MAXCOLOR) + 1

Subdivide MINX, MINY, MAXX, MAXY
LOCATE 24, 1: PRINT "Done";
Pause

CLS
LINE (1, MAXY)-(256, MAXY - 256), 7, BF
LINE (0, MAXY)-(256, MAXY - 257), 8, B
maxvalue = 0
' I'm skipping 1 and 256 because they are so much larger than others
FOR i = 5 TO 250
	IF HISTO(i) > maxvalue THEN maxvalue = HISTO(i)
NEXT i

FOR i = 5 TO 250
	LINE (i, MAXY - 1)-(i, MAXY - ((HISTO(i) / maxvalue) * MAXY)), i
NEXT i

Pause

SUB Adjust (xa, ya, x, y, xb, yb) STATIC
	Adjust1 xa, ya, x, y, xb, yb
'    Adjust2 xa, ya, x, y, xb, yb
END SUB

SUB Adjust1 (xa, ya, x, y, xb, yb)
'STATIC d AS INTEGER, v AS SINGLE

	IF Getpixel(x, y) <> BGCOLOR THEN EXIT SUB
	
	d = ABS(xa - xb) + ABS(ya - yb)
	r2 = Distribution(2)
	v = (Getpixel(xa, ya) + Getpixel(xb, yb)) / 2 + (r2 - .5) * d * GRANULARITY
	IF v < 1 THEN v = 1
	IF v >= MAXCOLOR THEN v = MAXCOLOR
	Putpixel x, y, FIX(v)
END SUB

SUB Adjust2 (xa, ya, x, y, xb, yb)
'STATIC d AS INTEGER, c AS SINGLE, horz, vert AS INTEGER
' This version was translated from OOZE.C

'    k$ = INKEY$: IF k$ = CHR$(27) THEN END
	
	IF Getpixel(x, y) <> BGCOLOR THEN EXIT SUB
	horz = xb - xa
	vert = yb - ya
	d = Sqrt(horz * horz + vert * vert)
	IF RND(2) THEN
		c = (Getpixel(xa, ya) + Getpixel(xb, yb)) / 2 - (RND(d)) MOD 252
	ELSE
		c = (Getpixel(xa, ya) + Getpixel(xb, yb)) / 2 + (RND(d)) MOD 252
	END IF
	IF c < 0 THEN
		 c = -c
	ELSE
		IF c = 0 THEN c = 1
	END IF
	Putpixel x, y, ABS(c)
END SUB

FUNCTION CubicBlend (t, N1, N2, P1, P2) STATIC
	CubicBlend = (1 - t) ^ 3 * N1 + (t ^ 3) * N2 + 3 * t * ((1 - t) ^ 2) * P1 + 3 * (t ^ 2) * (1 - t) * P2
END FUNCTION

FUNCTION Distribution (x)
	'Distribution = Gauss!(15)
	'Distribution = RND
	Distribution = CubicBlend(RND, 0, 1, 1, 0)
	'Distribution = HermiteBlend(RND, 0, 1, 1, 1)
END FUNCTION

FUNCTION Gauss! (samples%)
STATIC i%, sum!
	sum! = 0
	FOR i% = 1 TO samples%
		sum! = sum! + RND
	NEXT i%
	Gauss! = sum! / samples%
END FUNCTION

FUNCTION Getpixel (x, y) STATIC
	Getpixel = POINT(x, y)
END FUNCTION

FUNCTION HermiteBlend (t, N1, N2, P1, P2)
	HermiteBlend = (N1 * ((2! * t - 3!) * t ^ 2 + 1!) + N2 * (-2! * t + 3!) * t ^ 2 + P1 * ((t - 2!) * t + 1!) * t + P2 * (t - 1!) * t ^ 2)
END FUNCTION

FUNCTION LathamBlend (angle) STATIC
' Lathams cosine move in, pause, move out.  For angles from
'-90 to 90:
	
IF (angle < 0) THEN
   p = COS(angle) - 1
ELSE
   p = 1 - COS(angle)
END IF
LathamBlend = p
END FUNCTION

FUNCTION LinearBlend (t, N1, N2) STATIC
	LinearBlend = (1 - t) * N1 + t * N2
END FUNCTION

SUB Pause STATIC
	k$ = ""
	WHILE k$ = "": k$ = INKEY$: WEND
	IF k$ = CHR$(27) THEN END
END SUB

SUB Putpixel (x, y, c) STATIC
HISTO(c) = HISTO(c) + 1
	 size = 0
	 IF size = 0 THEN
		 PSET (x, y), c
	 ELSE
		x1 = x - size: y1 = y - size
		x2 = x + size: y2 = y + size
		IF x1 < MINX THEN x1 = MINX
		IF y1 < MINY THEN y1 = MINY
		IF x2 > MAXX THEN x2 = MAXX
		IF y2 > MAXY THEN y2 = MAXY
		LINE (x1, y1)-(x2, y2), c, BF
	 END IF
	 k$ = INKEY$: IF k$ = CHR$(27) THEN END
END SUB

FUNCTION QuadraticBlend (t, N1, N2, P1) STATIC
	QuadraticBlend = (1 - t) ^ 2 * N1 + (t ^ 2) * N2 + 2 * t * (1 - t) * P1
END FUNCTION

FUNCTION Sqrt& (n&) STATIC
	IF n& < 0 THEN n& = -n&
	xl& = 0
	xh& = 46340
	WHILE (xl& < xh& - 1)
		x& = (xl& + xh&) / 2
		y& = x& * x&
		IF y& < n& THEN xl& = x& ELSE xh& = x&
	WEND
	IF (n& - xl& * xl& < xh& * xh& - n&) THEN
		Sqrt& = INT(xl&)
	ELSE
		Sqrt& = INT(xh&)
	END IF
END FUNCTION

SUB Subdivide (x1, y1, x2, y2)
'STATIC x0, y0 AS INTEGER, v  AS SINGLE, k$

	IF (x2 - x1 < 2) AND (y2 - y1 < 2) THEN EXIT SUB

	x0 = (x1 + x2) / 2
	y0 = (y1 + y2) / 2

	Adjust x1, y1, x0, y1, x2, y1
	Adjust x2, y1, x2, y0, x2, y2
	Adjust x1, y2, x0, y2, x2, y2
	Adjust x1, y1, x1, y0, x1, y2
	
	
	IF Getpixel(x0, y0) = BGCOLOR THEN
		c = (Getpixel(x1, y1) + Getpixel(x2, y1) + Getpixel(x2, y2) + Getpixel(x1, y2)) / 4
		IF c < 1 THEN c = 1
		IF c > 255 THEN c = 255
		Putpixel x0, y0, c
	END IF
	
	Subdivide x1, y1, x0, y0
	Subdivide x0, y1, x2, y0
	Subdivide x0, y0, x2, y2
	Subdivide x1, y0, x0, y2
END SUB

FUNCTION XanderBlend (t, P1) STATIC
	XanderBlend = (((2 * t * t * t) - (3 * t * t) + 1) ^ P1)
END FUNCTION

