defdbl a-z
const FALSE= 0
const TRUE = NOT FALSE
CONST PI = 3.141592653589#

Main:
  print "STAR generator for PVRAY 1.0  by K. Koehler  v1.2"
  print
  ' 02-07-91 KJK New program for DKB 2.05AB
  ' 03-21-92 KJK Updated for PVRAY 0.51, added bounding, now stars are objects
  '              Added .INC file (object only) versus .DAT (view/lights/etc)
  ' 08-25-92 KJK Updated for POVRay 1.0. .POV and .INC are no longer optional.
  '              Darker shadowing to show off shape.

  input "Number of points        :";p
  input "Point Top    from center:";t
  input "Point Bottom from center:";b
  input "Point Joint  from center:";j
  input "Thickness    from center:";th
  screen 1 : color 7
  if t>b then wy=t else wy=b
  if j>wy then wy=j
  'if th>wy then wy=th
  wy=wy*1.1				  ' allow % extra screen space
  wx=wy*1.5				  ' adjust aspect ratio
  window (-wx,-wy) - (wx,wy)
    open "stars.pov" for output as #1
    gosub DatTop
    print #1,"#include ";chr$(34);"stars.inc";chr$(34)
    gosub DatBottom
    close #1
    open "stars.inc" for output as #1
    print #1,"   #declare StarCol = color Blue
    print #1,"   //#declare StarTex = texture { color StarCol }
    print #1,"   #declare StarTex =
    print #1,"   texture { pigment { checker color Black color Silver}
    print #1,"   finish { ambient 0.4 diffuse 0.2 reflection 0.15 }} 
    print #1,"
    print #1,"   #declare Star ="
    print #1,"   object {"
    print #1,"   union {"
    print #1,"       // p=";p;"  t=";t;"  b=";b;"  j=";j;"  th=";th
    ark=2*pi/p/2
    pointx=cos(-2*ark): pointy=sin(-2*ark)
    a3x=pointx*b      : a3y=pointy*b	  : a3z=th
    c2x=cos(-ark)*j   : c2y=sin(-ark)*j   : c2z=0
    pset (c2x,c2y)
    for angle = 0 to (2*pi)-ark step ark*2
	pointx=cos(angle): pointy=sin(angle)
	a1x=pointx*t	     : a1y=pointy*t	    : a1z=0
	line -(a1x,a1y),1
	b1x=pointx*b	     : b1y=pointy*b	    : b1z=th
	c1x=cos(angle+ark)*j : c1y=sin(angle+ark)*j : c1z=0
	line -(c1x,c1y),1
	c4x=0	: c4y=0   : c4z=th
	gosub WritePoint
	a3x=b1x : a3y=b1y : a3z=b1z
	c2x=c1x : c2y=c1y : c2z=c1z
    next angle
    print #1,	   "    }
    print #1,	   "    texture { StarTex }
    print #1,      "    bounded_by { intersection {"
    print #1,	   "        quadric { Cylinder_Z";
    print #1,using "   scale <###.####, ###.####, 1> }";wy;wy
    print #1,using "   plane { < 0, 0, 1> ###.#### }";th*1.1
    print #1,using "   plane { < 0, 0, -1> ###.#### }}}}";th*1.1
    close #1
  while inkey$="":wend
end

WritePoint:
  current.point%=current.point%+1
  print #1, using "       // Point #### ";current.point%

  print #1, using "      triangle { <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####> }" ;a1x;a1y; a1z  ;b1x;b1y; b1z  ;c1x;c1y; c1z
  print #1, using "      triangle { <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####> }" ;a1x;a1y; a1z  ;b1x;b1y; b1z  ;c2x;c2y; c2z
  print #1, using "      triangle { <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####> }" ;a3x;a3y; a3z  ;b1x;b1y; b1z  ;c2x;c2y; c2z
  print #1, using "      triangle { <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####> }" ;a3x;a3y; a3z  ;b1x;b1y; b1z  ;c4x;c4y; c4z

  print #1, using "      triangle { <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####> }" ;a1x;a1y; a1z  ;b1x;b1y;-b1z  ;c1x;c1y; c1z
  print #1, using "      triangle { <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####> }" ;a1x;a1y; a1z  ;b1x;b1y;-b1z  ;c2x;c2y; c2z
  print #1, using "      triangle { <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####> }" ;a3x;a3y;-a3z  ;b1x;b1y;-b1z  ;c2x;c2y; c2z
  print #1, using "      triangle { <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####>, <###.####, ###.####, ###.####> }" ;a3x;a3y;-a3z  ;b1x;b1y;-b1z  ;c4x;c4y;-c4z
return

DatTop:
  print #1,"// Persistence of Vision Raytracer
  print #1,"  #include ";chr$(34);"shapes.inc";chr$(34)
  print #1,"  #include ";chr$(34);"colors.inc";chr$(34)
  print #1,"  #include ";chr$(34);"textures.inc";chr$(34)
  print #1,"
return

DatBottom:
  print #1,"
  print #1,"  camera {
  print #1,using "   location <0,  0,  ###.####>";-3*wy
  print #1,"   direction <0, 0,  1>
  print #1,"   up  <0,  1,  0>
  print #1,"   right <4/3, 0, 0>
  print #1,"   look_at <0, 0, 0>}
  print #1,"
  print #1,"   plane { <0, 1, 0> ";-wx;
  print #1,"   texture { pigment { checker color Red color White }
  print #1,"   scale <";2*wy;" ";2*wy;" ";2*wy;">"
  print #1,"   finish { ambient 0.4 diffuse 0.2 reflection 0.13 }}}
  print #1,"
  print #1,"   object { Star }
  print #1,"
  print #1,"   light_source { ";
  print #1,"   <";10*wy;" ";12*wy;" ";-13*wy;"> color White }"
return
