DECLARE SUB GetBounds (X!, Y!, z!, maxx!, maxy!, maxz!, MINY!)
DECLARE SUB Perspective (rho!, d!, X!, Y!, z!, s1!, c1!, s2!, c2!, sx!, sy!)
DECLARE SUB DISPMSG (MSG$)
DECLARE SUB DKBHeader (viewer.distance!)
DECLARE SUB BeginComposite ()
DECLARE SUB EndComposite (maxx!, maxy!, maxz!, MINY!, scale!)
DECLARE SUB GUIPANEL (WLEFT%, WTOP%, WRIGHT%, WBOTTOM%, TOGGLE%)
DECLARE SUB GUIBOLT (X%, Y%, R%, TOGGLE%)
DECLARE SUB SAVECURS (V!, H!)
DECLARE SUB KEYFLUSH ()
DECLARE SUB GETKEY (A$)
DECLARE SUB CLEARMSG ()
DECLARE SUB DISPERR (MSG$, A$)
' SURFACE.BAS
' A 3-D function plotter that writes DKB data files using TRIANGLES.
' Requires EGA monitor or better (ya gotta have VGA for DKB, anyway)
' DKB Objects are SPHERES, color determined by X,Y,& Z for R,G & G.
'
' Conversion notes:
'     DEF FNfunctionname(parms) is a function that returns a value.
'     SUB function END SUB is a void function (CALL'ed)
'     PRINT USING "###.##",X  translates to printf("000.00\n",x)
'     A semicolon at the end of a printed line means no CR/LF
'     The PRINT USING statements cannot have the underscore character in
'         them because BASIC takes it as a line-continuation character,
'         thus, the lines containing them, such as END_OBJECT, have to
'         be broken up for BASIC.

FALSE = 0: TRUE = NOT FALSE
ESC$ = CHR$(27)
'------------------------ USER-DEFINED FUNCTIONS
'          ---  LOOK FOR A KEYSTROKE
DEF FNLOOKKEY$ (X)
	STATIC A$
	A$ = INKEY$
	IF LEN(A$) = 2 THEN             ' FILTER UNUSED CONTROL CODES
		IF ASC(RIGHT$(A$, 1)) > 81 THEN A$ = ""
	END IF
	FNLOOKKEY$ = A$
END DEF

'          ---  CONVERT STRING TO UPPER CASE
DEF FNUPPER$ (X$)
	STATIC A$, I%
	IF LEN(X$) > 0 THEN
		FOR I% = 1 TO LEN(X$)
			A$ = MID$(X$, I%, 1)
			IF A$ >= "a" AND A$ <= "z" THEN MID$(X$, I%, 1) = CHR$(ASC(A$) - 32)
		NEXT I%
	END IF
	FNUPPER$ = X$
END DEF
'          ---  LEFT-JUSTIFY, BLANK FILL A STRING
DEF FNPAD$ (X$, LENG) = LEFT$(X$ + SPACE$(LENG), LENG)

'          ---  REMOVE LEADING AND TRAILING SPACES
DEF FNUNPAD$ (X$)
	WHILE LEFT$(X$, 1) = " "
		X$ = MID$(X$, 2)
	WEND
	WHILE RIGHT$(X$, 1) = " "
		X$ = LEFT$(X$, LEN(X$) - 1)
	WEND
	FNUNPAD$ = X$
END DEF

'------------------ PLOTTING FUNCTIONS ------------------------------------
' Alternate functions.  Number FNf1, FNf2, etc. and change FNf(x<z)
DEF FNf1 (X, z) = 1.5 * SIN(.1 * (X * X + z * z))
DEF FNf2 (X, z) = SIN(-1.5 * SIN((X * X) + (z * z)))
DEF FNf3 (X, z) = -7 * EXP(-.1 * (X * X + z * z))
DEF FNf4 (X, z)
	w = X * X + z * z
	FNf4 = 14 * EXP(-.04 * w) * COS(-.15 * w)
END DEF
DEF FNf5 (X, z) = 5 * EXP(-.1 * ((X * X) + (z * z)))
DEF FNf6 (X, z) = COS(.1 * (X * X + z * z))
DEF FNHypot (X, Y) = SQR(X * X + Y * Y)

'=========== PRIMARY FUNCTION F(x,z)
DEF FNf (X, z) = FNf4(X, z)             ' edit this one to switch functions
'===========
'--------------------------------------------------------------------------
GOSUB InitScreen

 ' Initialize hidden=line buffer
DIM YMIN(639), YMAX(639)
FOR I = 0 TO 639
	YMIN(I) = 199
	YMAX(I) = 0
NEXT I

WINDOW (-1, -4)-(1, 4)
rho = 50      ' distance, viewer to object origin /default=30
d = 10        ' distance from viewer screen plane /default=10
theta = .3    ' viewer angle 1 (rotate left-right) /default=.3
phi = 1.25       ' viewer angle 2 (something like rotate up/down)  /default=1

s1 = SIN(theta)
c1 = COS(theta)
s2 = SIN(phi)
c2 = COS(phi)

xstep = .5: zstep = .5
resolution% = 10

maxx = 0: maxy = 0: maxz = 0: MINY = 99999   ' Used to scale bounding box
color.scale = resolution% * 2
xsize = 1 + (resolution% * 2) * xstep
zsize = 1 + (resolution% * 2) * zstep

NUMPOINTS = ((resolution% * 2) + 1) * (1 / xstep)
DIM Points(NUMPOINTS, NUMPOINTS)               ' y=point(x,z)
DKBScale = 10
DKBviewer.distance = -(NUMPOINTS * DKBScale)' (APPROXIMATLY CORRECT)

count% = 0


FOR X = resolution% TO -resolution% STEP -xstep
	xi = xi + 1
	zi = 0
	first.point.set = TRUE             ' first point on a curve
	FOR z = -resolution% TO resolution% STEP zstep
		sx = 0: sy = 0                   ' init new screen x & y
		Y = FNf(X, z)

		' buffer the y-values for the DKB output
		Points(X + resolution%, z + resolution%) = Y

		' track min's and max's for bounding box
		CALL GetBounds(X, Y, z, maxx, maxy, maxz, MINY)

		' set the perspective for the screen preview only
		CALL Perspective(rho, d, X, Y, z, s1, c1, s2, c2, sx, sy)

		' draw the screen image
		kolor = 8 - Y MOD 15 + 1
		IF kolor = BG% THEN kolor = NOT kolor
		IF first.point.set = TRUE THEN
			PSET (sx, sy), kolor      ' set a point
			first.point.set = FALSE   ' toggle the flag
		END IF
		LINE -(sx, sy), kolor         ' Draw relative to last point set

		' Poll the keyboard
		kbhit$ = INKEY$               ' Check keybuffer
		IF kbhit$ = SPACE$(1) THEN    ' Pause on spacebar press
			WHILE INKEY$ = "": WEND   ' Wait for another keypress
		ELSEIF kbhit$ = ESC$ THEN
			END                       ' exit program
		END IF
	NEXT z
NEXT X
CALL DISPMSG("Finished ([W]=Write POV  [Space]=End ")
A$ = ""
WHILE A$ = "": A$ = INKEY$: WEND
IF INSTR("Ww", A$) = 0 THEN END


WRITE.POV.FILE:
' Open output file
OPEN "SURFKEN.POV" FOR OUTPUT AS #1
CALL DKBHeader(DKBviewer.distance)
CALL BeginComposite
FOR X = resolution% TO -resolution% STEP -xstep
	FOR z = -resolution% TO resolution% STEP zstep
		xp = X + resolution%: zp = z + resolution%

		yp = Points(xp, zp)
		red = ABS(xp) / 10
		green = 1! - red
		blue = ABS(zp) / 10
		IF raw.triangles THEN
			GOSUB WRITE.RAWTRIANGLES
		ELSE
                        PRINT #1, USING " triangle {<###.####, ###.####, ###.####>"; X; Points(xp, zp); z;
                        PRINT #1, USING " <###.####, ###.####, ###.####>"; X + 1; Points(xp + 1, zp); z;
                        PRINT #1, USING " <###.####, ###.####, ###.####>}"; X; Points(xp, zp + 1); z + 1;
       '                 PRINT #1, USING " pigment { color red #.## green #.## blue #.## }"; red; green; blue;
       '                 PRINT #1, "finish { Shiny }}"

                        PRINT #1, USING " triangle {<###.####, ###.####, ###.####>"; X; Points(xp, zp + 1); z + 1;
                        PRINT #1, USING " <###.####, ###.####, ###.####>"; X + 1; Points(xp + 1, zp + 1); z + 1;
                        PRINT #1, USING " <###.####, ###.####, ###.####>}"; X + 1; Points(xp + 1, zp); z;
        '                PRINT #1, USING " pigment { color red #.## green #.## blue #.## } "; red; green; blue;
        '                PRINT #1, "finish { Shiny }}"
			count% = count% + 2
		END IF
	NEXT z
NEXT X

CALL EndComposite(maxx, maxy, maxz, MINY, DKBScale)
PRINT #1, USING "{ ##### triangles generated.}"; count%
CLOSE #1
CALL DISPMSG("Data sent to local file named SURFKEN.POV")
END

WRITE.RAWTRIANGLES:
        PRINT #1, USING "###.####, ###.####, ###.####"; X; Points(xp, zp); z;
        PRINT #1, USING "###.####, ###.####, ###.####"; X + 1; Points(xp + 1, zp); z;
        PRINT #1, USING "###.####, ###.####, ###.####"; X; Points(xp, zp + 1); z + 1

        PRINT #1, USING "###.####, ###.####, ###.####"; X; Points(xp, zp + 1); z + 1;
        PRINT #1, USING "###.####, ###.####, ###.####"; X + 1; Points(xp + 1, zp + 1); z + 1;
        PRINT #1, USING "###.####, ###.####, ###.####"; X + 1; Points(xp + 1, zp); z
RETURN

' SUB-ROUTINE InitScreen
' SETS SCREEN MODE 9
' DRAWS GUI-LOOKING SCREEN TO MAKE USER THINK HE'S GOT WINDOW 3.0 OR SOMETHING
' PRINTS THE TITLE AND MY NAME
' SETS A VIEW WINDOW
InitScreen:
	SCREEN 9, 1, 0, 0        ' Initialize graphics mode, page
	COLS% = 640: ROWS% = 350: XCENTER% = COLS% / 2: YCENTER% = ROWS% / 2
	WINTOP% = 16: WINBOTTOM% = ROWS% - 50: WINLEFT% = XCENTER% / 2 + 20: WINRIGHT% = COLS% - 10
	WINXCENTER% = (WINRIGHT% - WINLEFT%) / 2: WINYCENTER% = (WINBOTTOM% - WINTOP%) / 2
	BG% = 7                          ' SCREEN BACKGROUND COLOR (7 = gray)

	' Create an GUI-looking window for the data entry fields.
	CALL GUIPANEL(8, WINTOP%, WINLEFT% - 8, WINBOTTOM%, 2)        ' RAISED PANEL
	CALL GUIPANEL(16, 190, WINLEFT% - 16, WINBOTTOM% - 8, 1)      ' RAISED PANEL

	' COLORED DOTS "LOGO"
	CALL GUIBOLT(65, 240, 10, 1)
	CALL GUIBOLT(90, 240, 10, 1)
	CALL GUIBOLT(115, 240, 10, 1)
	CIRCLE (65, 240), 8, 2: PAINT (65, 240), 2
	CIRCLE (90, 240), 8, 5: PAINT (90, 240), 5
	CIRCLE (115, 240), 8, 9: PAINT (115, 240), 9

	' The sunken panel can be printed in from rows 15-20
	' starting at column 4 for a length of 18 Characters.
	'                   123456789012345678
	LOCATE 15, 4: PRINT "  3-D Functions  "
	LOCATE 16, 4: PRINT "    Generator    "
        LOCATE 20, 4: PRINT "  By Dan Farmer :  Appended By Ken Tyler 12/97 "

	CALL GUIBOLT(10, 8, 4, 1)                        ' UPPER LEFT BOLT
	CALL GUIBOLT(COLS% - 10, 8, 4, 1)                ' UPPER RIGHT BOLT

	' Create panel for messages at screen bottom
	CALL GUIPANEL(8, WINBOTTOM% + 8, WINRIGHT%, ROWS% - 8, 2)
	CALL GUIBOLT(24, ROWS% - 24, 4, 1)
	CALL GUIBOLT(WINRIGHT% - 24, ROWS% - 24, 4, 1)


	' Create a GUI-looking window for the image display
	CALL GUIPANEL(WINLEFT%, WINTOP%, WINRIGHT%, WINBOTTOM%, -3)    'SUNKEN PANEL

	VIEW (WINLEFT% + 8, WINTOP% + 8)-(WINRIGHT% - 8, WINBOTTOM% - 8)
	COLOR 8, BG%                                       ' BRITE WHITE
RETURN

' save
'        PRINT #1, USING "OBJECT TRIANGLE< ###.###### ###.###### ###.######>";x,   Points(xp,  zp  ), z;
'        PRINT #1, USING               "< ###.###### ###.###### ###.######>"; x+1, Points(xp+1,zp  ), z;
'        PRINT #1, USING               "< ###.###### ###.###### ###.######>"; x,   Points(xp,  zp+1), z+1;
'        PRINT #1, " END_TRIANGLE COLOR ColorOne TEXTURE TextureOne END_TEXTURE END_OBJECT"
'
'        PRINT #1, USING "OBJECT TRIANGLE< ###.###### ###.###### ###.######>";x,   Points(xp,  zp+1), z+1;
'        PRINT #1, USING               "< ###.###### ###.###### ###.######>"; x+1, Points(xp+1,zp+1), z+1;
'        PRINT #1, USING               "< ###.###### ###.###### ###.######>"; x+1, Points(xp+1,  zp), z;
'        PRINT #1, " END_TRIANGLE COLOR ColorOne TEXTURE TextureOne END_TEXTURE END_OBJECT"

SUB BeginComposite STATIC
	PRINT #1, "union {"
END SUB

'
'          ---  CLEAR MESSAGE AREA
SUB CLEARMSG STATIC
		CALL DISPMSG("")
END SUB

'          ---  DISPLAY ERROR MESSAGE
SUB DISPERR (MSG$, A$) STATIC
			'  MSG$ := MESSAGE TO DISPLAY
			'  A$   := CARRYOVER KEYSTROKE
		CALL DISPMSG(MSG$)
	PRINT BELL$;
	CALL KEYFLUSH
	CALL GETKEY(A$)
	CALL CLEARMSG
END SUB

'
'          ---  DISPLAY A MESSAGE
SUB DISPMSG (MSG$) STATIC
STATIC LEFT%, MAXLEN%
	MAXLEN% = 70
	LEFT% = (80 - MAXLEN%) / 2
	MSG$ = FNUNPAD$(MSG$)
	IF LEN(MSG$) > MAXLEN% THEN MSG$ = LEFT$(MSG$, MAXLEN%)' TRUNCATE IF NEEDED

	CALL SAVECURS(V, H)                     ' SAVE CURSOR POSITION
	LOCATE 24, LEFT%
	PRINT SPC(MAXLEN%);
	LOCATE 24, 40 - LEN(MSG$) / 2
	PRINT MSG$;
	LOCATE V, H, 1
END SUB

SUB DKBHeader (viewer.distance) STATIC
' Note: parm "viewer.distance" is not used at this time.

	PRINT #1, "#include" + CHR$(34) + "colors.inc" + CHR$(34)
	PRINT #1, "#include" + CHR$(34) + "textures.inc" + CHR$(34)
	PRINT #1, ""
	PRINT #1, "#declare Bbox = intersection {  // Used as a bounding shape}"
        PRINT #1, "        plane {< 0,  0,  1> 1}"
        PRINT #1, "        plane {< 0,  0, -1> 1}"
        PRINT #1, "        plane {< 0,  1,  0> 1}"
        PRINT #1, "        plane {< 0, -1,  0> 1}"
        PRINT #1, "        plane {< 1,  0,  0> 1}"
        PRINT #1, "        plane {<-1,  0,  0> 1}"
        PRINT #1, "        scale <  1,  1,  1>  }"
	PRINT #1, ""
	PRINT #1, ""
        PRINT #1, "  camera {"
        PRINT #1, USING "   location  <0, 5, ####.####>"; viewer.distance
	PRINT #1, "   direction <0, 0, 1>"
	PRINT #1, "   up  <0, 1, 0>"
        PRINT #1, "   right <4/3, 0, 0>"
	PRINT #1, "   look_at <0, 0, 0> }"
	PRINT #1, ""
	PRINT #1, ""
	PRINT #1, ""
	PRINT #1, ""
        PRINT #1, "   sphere { < 0, 0, 0 > 2 translate < 100, 500, -150 >"
        PRINT #1, "   pigment { color red 1 green 1 blue 1 }"
        PRINT #1, "   finish { ambient 1 diffuse 0 }" 
        PRINT #1, ""   
	PRINT #1, ""
        PRINT #1, "  light_source { <0, 40, -600 > color White }"
        PRINT #1, "  // Sky sphere"
        PRINT #1, "  sphere { < 0, 0, 0>  2000 "
        PRINT #1, "  pigment { color red 0.3 green 0.8 blue 1.0 } finish { ambient 1 diffuse 0 }}"
	PRINT #1, ""
'    PRINT #1, "DECLARE TextureOne = TEXTURE {insert texture here } END_TEXTURE"
'    PRINT #1, "DECLARE ColorOne = COLOR RED 1.0 "
END SUB

SUB EndComposite (maxx, maxy, maxz, MINY, scale) STATIC
	IF ABS(MINY) > maxy THEN maxy = ABS(MINY)
	PRINT #1, "    bounded_by { ";
	PRINT #1, "        intersection { Bbox"
	PRINT #1, USING "        scale < ###.##, ###.##, ###.##>}}"; maxx + 1; maxy + 1; maxz + 1
'   PRINT #1, "        END_INTERSECTION"
'   PRINT #1, "    END_BOUND"
        PRINT #1, USING "    scale <###.####, ###.####, ###.####>}"; scale; scale; scale
END SUB

SUB GetBounds (X, Y, z, maxx, maxy, maxz, MINY) STATIC
' Input :=x,y,z
' Output := maxbound
STATIC x1, y1, z1
	x1 = ABS(X)
	y1 = ABS(Y)
	z1 = ABS(z)
	IF x1 > maxx THEN maxx = x1
	IF y1 > maxy THEN maxy = y1
	IF z1 > maxz THEN maxz = z1
	IF Y < MINY THEN MINY = Y
END SUB

'
'          ---  GET KEYSTROKE
SUB GETKEY (A$) STATIC
	A$ = ""
	WHILE A$ = ""
		A$ = FNLOOKKEY$(0)
	 WEND
END SUB

SUB GUIBOLT (X%, Y%, R%, TOGGLE%) STATIC
STATIC DEPTH, I, INSET
' Parameter TOGGLE := -1 FOR INSET, 1 FOR OUTSET
'                     -2 FOR INSET 2 DEEP, 3 TO OUTSET 3 DEEP, ETC.
DEPTH% = ABS(TOGGLE%)
INSET% = (TOGGLE% < 0)
PI# = 4 * ATN(1!)

FOR I% = 0 TO DEPTH% - 1
	IF INSET% THEN                                 ' INSET BOLT
		CIRCLE (X%, Y%), R% - I%, 15, .5 * PI#, 1.5 * PI#
		CIRCLE (X%, Y%), R% - I%, 8, 1.5 * PI#, 0
	ELSE
		CIRCLE (X%, Y%), R% - I%, 8, .5 * PI#, 1.5 * PI#
		CIRCLE (X%, Y%), R% - I%, 15, 1.5 * PI#, 0
	END IF
NEXT I%
END SUB

SUB GUIPANEL (WLEFT%, WTOP%, WRIGHT%, WBOTTOM%, TOGGLE%) STATIC
STATIC DEPTH, I, INSET
' Parameter TOGGLE := -1 FOR INSET, 1 FOR OUTSET
'                     -2 FOR INSET 2 DEEP, 3 TO OUTSET 3 DEEP, ETC.
DEPTH% = ABS(TOGGLE%)
INSET% = (TOGGLE% < 0)

FOR I% = 0 TO DEPTH% - 1
	IF INSET% THEN                                 ' INSET PANEL
		LINE (WLEFT% + I%, WTOP% + I%)-(WLEFT% + I%, WBOTTOM% - I%), 8' LEFT SIDE
		LINE (WLEFT% + I%, WTOP% + I%)-(WRIGHT% - I%, WTOP% + I%), 8  ' TOP LINE
		LINE (WLEFT% + I%, WBOTTOM% - I%)-(WRIGHT% - I%, WBOTTOM% - I%), 15' BOTTOM LINE
		LINE (WRIGHT% - I%, WTOP% + I%)-(WRIGHT% - I%, WBOTTOM% - I%), 15' RIGHT SIDE
	ELSE                                             ' OUTSET PANEL
		LINE (WLEFT% + I%, WTOP% + I%)-(WLEFT% + I%, WBOTTOM% - I%), 15' LEFT SIDE
		LINE (WLEFT% + I%, WTOP% + I%)-(WRIGHT% - I%, WTOP% + I%), 15 ' TOP LINE
		LINE (WLEFT% + I%, WBOTTOM% - I%)-(WRIGHT% - I%, WBOTTOM% - I%), 8' BOTTOM LINE
		LINE (WRIGHT% - I%, WTOP% + I%)-(WRIGHT% - I%, WBOTTOM% - I%), 8' RIGHT SIDE
	END IF
NEXT I%
END SUB

'
'          ---  FLUSH KEYBOARD BUFFER
SUB KEYFLUSH STATIC
	WHILE INKEY$ <> ""
	WEND
END SUB

SUB Perspective (rho, d, X, Y, z, s1, c1, s2, c2, sx, sy) STATIC
' Parameters:
' Input:
' rho   :=  distance, viewer to object origin
' d     :=  distance from viewer screen plane
' x,y,z :=  points to be modified by perspective distortion
' s1,c1 :=  SIN/COS(theta) respectively.  Viewer angle 1
' s2,c2 :=  SIN/COS(phi)   respectively.  Viewer angle 2
' Output:
' sx,sy := new adjusted screen coordinates. Plot these points.
	STATIC xe, ye, ze
	xe = -X * s1 + z * c1
	ze = -X * c1 * c2 - z * s1 * c2 + Y * s2
	ye = -X * s2 * c1 - z * s1 * s2 - Y * c2 + rho
	sx = d * xe / ye
	sy = d * ze / ye
END SUB

'          ---  REMEMBER CURSOR POSITION
SUB SAVECURS (V, H) STATIC
	V = CSRLIN
	H = POS(0)
END SUB

'
'          ---  ASK OPERATOR A YES/NO QUESTION, RESET EXIT$ IF NO
SUB VERIFY (MSG$, EXIT$) STATIC
		CALL DISPERR(MSG$ + " (Y or N)?", B$)
		IF B$ <> "y" AND B$ <> "Y" THEN EXIT$ = ""
END SUB

